package org.softme.database;


import java.sql.Connection;
import java.sql.DriverManager;
import java.util.LinkedList;
import java.util.List;

/**
 * ConnectionManager
 * ݿӵĹ࣬ʹӳءĬϵСֱΪ5,10
 * ûֵָĬֵͲֵָ
 *
 * @author Michael Zeng
 * @version 1.0 September 18, 2002
 *
 * @todo: Ŀǰֻ֧һݿһӳءΪڹ캯ָݿ
 * ֲǺһloadProperty()һļֱӶȡ
 * ҿֶ֧ӳء
 */
public class ConnectionManager
{
    private static ConnectionManager instance = null;
    private ConnectionPool connPool = null;
    private String driver, url, user, passwd;
    private int minConn = 5, maxConn = 10;
    private final long PERIOD = 20000;  //̵߳ȴʱ20
    private final int TRY_TIMES = 5;    //ûпʱԴ

    /**
     * õConnectionManagerһΨһʵ
     *
     * @param _driver ݿ
     * @param _url ݿĵַ
     * @param _user ݿû
     * @param _passwd û
     * @param _minConn Сֵ֧Ŀ
     * @param _maxConn ֵ֧Ŀ
     * @return ConnectionManager Ψһʵ
     *
     * @throws Exception
     */
    public static ConnectionManager getInstance(String _driver, String _url, String _user,
            String _passwd, int _minConn, int _maxConn) throws Exception
    {
        if(instance == null)
        {
            instance = new ConnectionManager(_driver, _url, _user, _passwd,
                    _minConn, _maxConn);
        }
        return instance;
    }

    /**
     * ӳеõConncetionһʵ
     *
     * @return Connection ӵʵ쳣ʱnull
     *
     * @throws Exception
     */
    public Connection getConnection() throws Exception
    {
        return this.connPool.getConnection();
    }

    /**
     * һConnectionʵӳأѾ˳ص
     * Ͱͷš
     *
     * @param conn ҪصConnection
     *
     * @throws Exception
     */
    public void freeConncetion(Connection conn) throws Exception
    {
        this.connPool.freeConncetion(conn);
    }

    /**
     * ͷӳеConnection
     *
     * @throws Exception
     */
    public void close()throws Exception
    {
        this.connPool.release();
    }

    /**
     * õӳصʵʴС
     *
     * @return int ӳصĴС
     */
    public int getPoolSize()
    {
        return this.connPool.getPoolSize();
    }

    /**
     * ˽еĹ캯
     *
     * @param _driver ݿ
     * @param _url ݿĵַ
     * @param _user ݿû
     * @param _passwd û
     * @param _minConn Сֵ֧Ŀ
     * @param _maxConn ֵ֧Ŀ
     * @return ConnectionManager ʵ
     *
     * @throws Exception
     */
    private ConnectionManager(String _driver, String _url, String _user,
                              String _passwd, int _minConn, int _maxConn) throws Exception
    {
        this.driver = _driver;
        this.url = _url;
        this.user = _user;
        this.passwd = _passwd;
        //ûֵָĬֵͲֵָ
        this.minConn = Math.max(this.minConn, _minConn);
        this.maxConn = Math.max(this.maxConn, _maxConn);
        //ûָmin > maxǿֵ
        this.minConn = Math.min(this.minConn, this.maxConn);

        this.connPool = new ConnectionPool();
    }

    /**
     * ConnectionPool
     * inner class
     */
    private class ConnectionPool implements Runnable
    {
        private List pool = null;
        private Thread runner = null;
        private boolean runOver = false;//Ƿ̵߳ıʶ

        /**
         * 캯ʼӳеConnection
         *
         * @throws Exception
         */
        public ConnectionPool() throws Exception
        {
            this.pool = new LinkedList();
            //ʼСConnection
            for (int i = 0; i < minConn; i++)
            {
                this.pool.add(this.createConnection());
            }
            //߳
            runner = new Thread(this);
            runner.start();
        }

        /**
         * ʵRunnableӿڵķں̨Եļ⣬֤ӳеĿ
         * ĿССĿ
         */
        public void run()
        {
            while (true)
            {
                if(runOver == true) return;

                //ĿССĿʽ(minConn - pool.size())
                //ĽǴ0ִѭ
                int numOfLack = 0;
                if(this.pool != null)   numOfLack = minConn - pool.size();
                for (int i = 0; i < numOfLack; i++)
                {
                    try{    this.pool.add(this.createConnection()); }
                    catch (Exception ex){}
                }

                try{    Thread.sleep(PERIOD);   }
                catch (InterruptedException ex){}
            }// end of while()
        }

        /**
         * ӳеõConncetionһʵ
         *
         * @return Connection ӵʵ쳣ʱnull
         *
         * @throws Exception
         */
        public synchronized Connection getConnection() throws Exception
        {
            Connection conn = null;
            //ָĳ
            for (int i = 0; i < TRY_TIMES; i++)
            {
                if(this.pool.size() > 0)
                {
                    //ȡóеĵһ
                    conn = (Connection)this.pool.remove(0);
                    break;
                }
                else
                {
                    //ȴ
                    wait(PERIOD / 2);
                }
            }
            //ȴȻûпõ(ĳ쳣)null
            if(conn == null)    return null;
            //ȡõӲãݹԼ
            if(conn.isClosed()) conn = this.getConnection();
            return conn;
        }

        /**
         * һConnectionʵӳأѾ˳ص
         * Ͱͷš
         *
         * @param conn ҪصConnection
         *
         * @throws Exception
         */
        public synchronized void freeConncetion(Connection conn) throws Exception
        {
            //ЧӲҪس
            if(conn == null || conn.isClosed()) return;

            if(this.pool.size() < maxConn )
                this.pool.add(conn);
            else
                conn.close();
        }

        /**
         * ͷӳеConnection
         *
         * @throws Exception
         */
        public synchronized void release()throws Exception
        {
            Connection conn = null;
            for (int i = 0; i < this.pool.size(); i++)
            {
                conn = (Connection)this.pool.get(i);
                conn.close();
            }
            conn = null;
            this.pool = null;
            this.runOver = true; //Ƿ̵߳ıʶ
        }

        /**
         * õӳصʵʴС
         *
         * @return int ӳصĴС
         */
        public int getPoolSize()
        {
            return this.pool.size();
        }

        /**
         * helperһݿ
         *
         * @return Connection ݿ
         * @throws Exception
         */
        private Connection createConnection() throws Exception
        {
            Class.forName(driver);
            return DriverManager.getConnection(url,user, passwd);
        }
    }// inner class ConnectionPool

}