package org.softme.database;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * DBInfoImplõݿĻϢ
 *
 * @author Michael Zeng
 * @version 1.0 September 18, 2002
 */
public class DBInfoImpl implements DBInfo
{
	private Connection conn = null;
	private DatabaseMetaData dbmd = null;
	private ArrayList alTables = null;
	private HashMap hmTableColumns = null;

    DBInfoImpl(){}

    /**
     * ָһݿ
     *
     * @param conn ݿ
     */
	public void setConnection(Connection conn)
	{
    	this.conn = conn;
    }

	/**
	 * һݿеб
	 *
	 * @return String[] һݿеб
     *
     * @throws Exception
	 */
	public String[] getTables() throws Exception
	{
		//ȼǷҪѯݿ
        if(alTables == null)
        {
            alTables = new ArrayList();

            if(dbmd == null) setDBMD();
            ResultSet rsTables = dbmd.getTables(null, null,null, new String[] {"TABLE"});
            while (rsTables.next())
            {
                alTables.add(rsTables.getString("TABLE_NAME"));
            }// end of while
        }
        if(alTables.size() == 0)    return new String[0];
	    return (String[])alTables.toArray(new String[1]);
	}

	/**
	 * ݿĳضе
	 *
	 * @param table ָı
	 * @return String[] е
     *
     * @throws Exception
	 */
	public String[] getColumns(String table) throws Exception
	{
    	if (hmTableColumns == null) hmTableColumns = new HashMap();
    	ArrayList alColumns = new ArrayList();

        //ȼǷҪѯݿ
        if (!hmTableColumns.containsKey(table)) getTableColumns(table);

        ResultSet rsColumns = (ResultSet)hmTableColumns.get(table);
        while (rsColumns.next())
        {
            alColumns.add(rsColumns.getString("COLUMN_NAME"));
        }// end of while
        if(alColumns.size() == 0)   return new String[0];
	    return (String[])alColumns.toArray(new String[1]);
	}

	/**
     * ָݿĳָе
     *
     * @param table ָݿ
     * @param column ָ
     * @return еͣ쳣򷵻null
     *
     * @throws Exception
     */
    public String getColumnType(String table, String column) throws Exception
	{
    	if (hmTableColumns == null) hmTableColumns = new HashMap();
    	String columnType = null;

        //ȼǷҪѯݿ
        if (!hmTableColumns.containsKey(table)) getTableColumns(table);

        ResultSet rsColumns = (ResultSet)hmTableColumns.get(table);
        rsColumns.beforeFirst();
        while (rsColumns.next())
        {
            if(column.equalsIgnoreCase(rsColumns.getString("COLUMN_NAME")))
            {
                columnType = rsColumns.getString("TYPE_NAME");
                break;
            }
        }// end of while

    	return columnType;
    }


	/**
     * ƵݱǷѾ
     *
     * @param table 
     * @return Ѿڣtrue
     *
     * @throws Exception
     */
	public boolean isTableExist(String table) throws Exception
	{
		//ȼǷҪѯݿ
    	if(alTables == null) this.getTables();

    	if(alTables.contains(table))
    		return true;
    	else
    		return false;
    }

	/**
     * ڲʹõhelperԪ
     *
     *@throws SQLException
     */
	private void setDBMD() throws SQLException
	{
    	dbmd = conn.getMetaData();
    }

    /**
     * helperȡһָϢһHashMap
     *
     * @param table ָı
     *
     * @throws Exception
     */
    private void getTableColumns(String table) throws Exception
    {
        if(dbmd == null) setDBMD();
        ResultSet rsColumns = dbmd.getColumns(null, null, table, null);
        hmTableColumns.put(table, rsColumns);
    }
}
