package org.softme.database;

import java.io.InputStream;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
/**
 * SqlFacade
 * ݿӺͷ
 *
 * @author Michael Zeng
 * @version 1.0 September 18, 2002
 */
public class SqlFacade
{

	private Connection conn = null;
	private Statement stmt = null;
	private PreparedStatement prepstmt = null;


	/**
	 * ݿӺͷ,ʹStatement
	 *
	 * @param conn 
     *
     * @throws SQLException
	 */
	public SqlFacade(Connection conn) throws SQLException
	{
		this.conn = conn;
		stmt = this.conn.createStatement();
	}

    /**
     * ݿӺͷ,ʹStatementʹùĽĬαֻ
     *
     * @param conn 
     * @param isScrollSensitive Աʶ
     *
     * @throws SQLException
     */
    public SqlFacade(Connection conn, boolean isScrollSensitive) throws SQLException
    {
        this.conn = conn;
        if(isScrollSensitive == false)
            this.stmt = this.conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
        else
            this.stmt = this.conn.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,ResultSet.CONCUR_READ_ONLY);
	}

	/**
	 * ݿӺͷ,ʹPreparedStatement
	 *
	 * @param conn 
	 * @param sql ռλSQL
     *
     * @throws SQLException
	 */
	public SqlFacade(Connection conn, String sql) throws SQLException
	{
		this.conn = conn;
 		this.prepareStatement(sql);
	}

    /**
     * ݿӺͷ,ʹPreparedStatementʹùĽĬαֻ
     *
     * @param conn 
     * @param sql ռλSQL
     * @param isScrollSensitive Աʶ
     *
     * @throws SQLException
     */
    public SqlFacade(Connection conn, String sql,  boolean isScrollSensitive)
            throws SQLException
    {
        this.conn = conn;
        if(isScrollSensitive == false)
            this.prepareStatement(sql, ResultSet.TYPE_SCROLL_INSENSITIVE,ResultSet.CONCUR_READ_ONLY);
        else
            this.prepareStatement(sql, ResultSet.TYPE_SCROLL_SENSITIVE, ResultSet.CONCUR_READ_ONLY);
	}

	/**
	 * 
	 *
	 * @return Connection 
	 */
	public Connection getConnection()
	{
		return conn;
	}

	/**
	 * PreparedStatement
	 *
	 * @param sql ԤSQL
     *
     * @throws SQLException
	 */
	public void prepareStatement(String sql) throws SQLException
	{
		prepstmt = conn.prepareStatement(sql);
	}

    /**
     * PreparedStatementָͺͬ
     *
     * @param sql ռλSQL
     * @param resultSetType 
     * @param resultSetConcurrency ͬ
     *
     * @throws SQLException
     */
    public void prepareStatement(String sql, int resultSetType, int resultSetConcurrency)
            throws SQLException
    {
        prepstmt = conn.prepareStatement(sql, resultSetType, resultSetConcurrency);
	}

	public void setString(int index,String value) throws SQLException
	{
		prepstmt.setString(index,value);
	}
	public void setInt(int index,int value) throws SQLException
	{
		prepstmt.setInt(index,value);
	}
	public void setBoolean(int index,boolean value) throws SQLException
	{
		prepstmt.setBoolean(index,value);
	}
	public void setDate(int index,Date value) throws SQLException
	{
		prepstmt.setDate(index,value);
	}
	public void setLong(int index,long value) throws SQLException
	{
		prepstmt.setLong(index,value);
	}
	public void setFloat(int index,float value) throws SQLException
	{
		prepstmt.setFloat(index,value);
	}
	public void setBinaryStream(int index,InputStream in,int length) throws SQLException
	{
		prepstmt.setBinaryStream(index,in,length);
	}

	/**
     * 趨Ĳ
     *
     * @throws SQLException
     */
    public void clearParameters() throws SQLException
    {
        prepstmt.clearParameters();
    }

	/**
	 * Ԥ״̬׼
	 *
	 * @return PreparedStatement
	 */
	public PreparedStatement getPreparedStatement()
	{
		return prepstmt;
	}

	/**
	 * ״̬
	 * @return Statement ״̬
	 */
	public Statement getStatement()
	{
		return stmt;
	}

	/**
	 * ִSQL䷵ֶμʹStatement
	 *
	 * @param sql SQL
	 * @return ResultSet ֶμ
     *
     * @throws SQLException
	 */
	public ResultSet executeQuery(String sql) throws SQLException
	{
		if (stmt == null)   stmt = this.conn.createStatement();
        return stmt.executeQuery(sql);

	}

	/**
	 * ִ趨õPreparedStatement䷵ֶμʹPreparedStatement
     *
	 * @return ResultSet ֶμ
     *
     * @throws SQLException
     */
	public ResultSet executeQuery() throws SQLException
	{
		if (prepstmt != null)
			return prepstmt.executeQuery();
		else
			return null;
	}

	/**
	 * ִSQL Update,ʹStatement
	 *
	 * @param sql SQL
     *
     * @throws SQLException
	 */
	public void executeUpdate(String sql) throws SQLException
	{
        if (stmt == null)   stmt = this.conn.createStatement();
        stmt.executeUpdate(sql);
	}

	/**
	 * ִSQL Update,ʹPreparedStatement
	 *
     * @throws SQLException
	 */
	public void executeUpdate() throws SQLException
	{
		if (prepstmt != null)
			prepstmt.executeUpdate();
	}

	/**
	 * رStatementPreparedStatement
     *
     * @throws SQLException
	 */
	public void close() throws SQLException
	{
		if (stmt != null)
		{
			stmt.close();
			stmt = null;
		}
		if (prepstmt != null)
		{
			prepstmt.close();
			prepstmt = null;
		}
	}
}
