package org.softme.database.datalist;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * AbstractPageһʹ{@link ResultSetPage ResultSetPage}ĳࡣ
 * еҪһConnection͵connʵ
 * ʼķ<br>
 * зװڷҳʾѯĴ󲿷ֲ:
 * <pre>
 * ʹ{@link getColumns() getColumns()}ȡʽıѯֶ
 * ʹ{@link getRecords() getRecords()}Զάʽȡҳʾ
 * ʹ{@link getNavigator(String) getNavigator(String)}õhtml
 * </pre>
 * AbstractPageʵĳ󷽷
 * <pre>
 * ʼconnķ{@link initiateConnection() initiateConnection()}
 * òѯķ{@link doQuery() doQuery()}
 * </pre>
 * ʹ÷
 * <pre>
 *          public class ShowPageBean extends AbstractPage
 *          {
 *              public ShowPageBean() throws Exception{}
 *
 *              public void initiateConnection() throws Exception
 *              {
 *                  //ʹû趨ıĬֵcountPerPage=5
 *                  this.countPerPage = Config.getCountPerPage();
 *                  this.conn = Pool.getConnection();
 *              }
 *
 *              public ResultSet doQuery() throws Exception
 *              {
 *                  //do some SQL query here
 *                  ResultSet rs = ...
 *                  return rs;
 *              }
 *          }
 * </pre>
 *
 * @author Michael Zeng
 * @version 1.0 September 24, 2002
 */
public abstract class AbstractPage
{
    protected Connection conn = null;
    protected ResultSetPage page = null;
    protected DataList chunk = null;
    protected DataListIterator it = null;

    protected int startIndex = 0, countPerPage = 5;
    protected String navigatorSymbol[] = new String[]{    "&lt;--", "--&gt;" };
    protected String navigatorColor[] = new String[]{  "color:blue","color:red"   };

    public void setStartIndex(int startIndex){    this.startIndex = startIndex;    }
    public int getStartIndex(){    return this.startIndex;    }

    /**
     * protected췽
     *
     * @throws Exception
     */
    protected AbstractPage() throws Exception
    {
        initiateConnection();
        page = new ResultSetPage(conn, doQuery());
    }

    /**
     * 󷽷ڳʼеConnectionʹTemplate Pattern
     * ʵӳٵж塣
     *
     * @throws Exception
     */
    abstract public void initiateConnection()throws Exception;

    /**
     * 󷽷òѯʹTemplate Patternʵӳٵ
     * ж塣
     *
     * @return ResultSet ʾĲѯ
     * @throws Exception
     */
    abstract public ResultSet doQuery() throws Exception;

    /**
     * õѯֶ
     *
     * @return String[] ֶ
     */
    public String[] getColumns()
    {
        if(page == null)    return new String[0];
        else    return page.getColumns();
    }

    /**
     * õָΧڵĽֵάʾеĽֵһάʾһжļ
     * ¼ڶάʾһ¼еÿֵ
     *
     * @return String[][] ָΧڵĽֵ
     * @throws Exception
     */
    public String[][] getRecords() throws Exception
    {
        if(page == null)    return new String[0][0];

        //ȡָΧӼӼС÷ֵĴС
        chunk = page.getListChunk(startIndex, countPerPage);
        String[][] records = new String[chunk.size()][];
        it = chunk.iterator();

        int i = 0;
        while (it.hasNext())
        {
            records[i] = it.next();
            i++;
        }
        return records;
    }

    /**
     * õһηҳʾʹõĵhtml롣Ĭʽ:
     * <p style="color:blue">&lt;-- 1 2 3 <font color="red">4</font> 5 --&gt;</p>
     *
     * @param targetPage Ҫˢµҳƣһǵǰҳơ
     * @return html
     * @throws SQLException
     */
     public String getNavigator(String targetPage) throws SQLException
    {
        StringBuffer sb = new StringBuffer("");
        //ʹComposite Pattern˽зĿStringBufferид
        appendSymbolNavigator(sb, targetPage, true);
        appendNumNavigator(sb, targetPage);
        appendSymbolNavigator(sb, targetPage, false);

        return sb.toString();
    }

    /**
     * ͷԴ(ݿ)
     *
     * @throws SQLException
     */
    public void close() throws SQLException
    {
        if(page != null)
        {
            page.close();
            page = null;
        }
        if(chunk != null)
        {
            chunk = null;
        }
    }

    /**
     * packageڸStringBufferĩβ׷ӵhtml롣
     *
     * @param sb StringBuffer
     * @param targetPage Ҫˢµҳ
     * @param isPrevious trueʾPREVIOUSţfalseʾNEXT
     * @throws SQLException
     */
    protected void appendSymbolNavigator(StringBuffer sb, String targetPage,
                                      boolean isPrevious) throws SQLException
    {
        if(isPrevious && !page.hasPrevious())    return;
        if(!isPrevious && !page.hasNext())  return;

        int targetIndex = startIndex + countPerPage;
        String targetSymbol = navigatorSymbol[1];
        if(isPrevious)
        {
            targetIndex = startIndex - countPerPage;
            targetSymbol = navigatorSymbol[0];
        }

        sb.append("<a style='text-decoration: none' href='");
        sb.append(targetPage).append("?startIndex=").append(targetIndex);
        sb.append("'>").append(targetSymbol).append("</a>&nbsp;");
    }

    /**
     * packageڸStringBufferĩβ׷ӵҳֵhtml롣
     *
     * @param sb StringBuffer
     * @param targetPage Ҫˢµҳ
     * @throws SQLException
     */
    protected void appendNumNavigator(StringBuffer sb, String targetPage)
            throws SQLException
    {
        int total = page.size()/countPerPage + 1;
        String color = navigatorColor[0];
        for(int i = 0; i < total; i++)
        {
            if( startIndex/countPerPage == i) color = navigatorColor[1];
            else color = navigatorColor[0];
            sb.append("<a style='text-decoration: none;").append(color + "' ");
            sb.append("href='").append(targetPage).append("?startIndex=");
            sb.append(i * countPerPage).append("'>").append(i + 1).append("</a>&nbsp;");
        }
    }

}