package org.softme.database.datalist;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * ResultSetDataListʵDataListӿڣResultSetʹá
 *
 * ʾһѯResultSetļ͡
 * @author Michael Zeng
 * @version 1.0 September 20, 2002
 */
public class ResultSetDataList implements DataList
{
    private RowMapper mapper = null;
    private Connection conn = null;
    private ResultSet rs = null;

    //¼ResultSetǰλϢ
    private boolean currIsBefore = false, currIsAfter = false;
    private int currIndex = 0;

    /**
     * package캯
     *
     * @param mapper ȡýֵRowMapper
     * @param conn ݿ
     * @param rs ѯ
     */
    ResultSetDataList(RowMapper mapper, Connection conn, ResultSet rs)
    {
        this.mapper = mapper;
        this.conn = conn;
        this.rs = rs;
    }

    /**
     * ȡָλòѯеֵֶŵһַвء
     * java.util.List.get(int)
     *
     * @param index ѯ
     * @return String[] еֵֶ
     *
     * @throws SQLException
     */
    public String[] get(int index) throws SQLException
    {
        if(index < 0 ) throw new IndexOutOfBoundsException("ָԽ!");
        rs.absolute(index + 1);
        if(rs.getRow() != (index +1))   throw new IndexOutOfBoundsException();

        try{    return mapper.rowMap(rs);    }
        catch (SQLException ex)
        {    throw new SQLException("ȡֵֶ쳣 " + ex.getMessage());    }
    }

    /**
     * ѯļǷΪռ
     *
     * @return boolean trueʾռ
     * @throws SQLException
     */
    public boolean isEmpty() throws SQLException
    {
        boolean isNotBefore = !rs.isBeforeFirst();
        boolean isNotAfter = !rs.isAfterLast();
        //rs.getRow()==0ʾûеǰ
        boolean hasNoCurr = (rs.getRow()==0 ? true: false);

        return isNotBefore && isNotAfter && hasNoCurr;
    }

    /**
     * Ƿһѯ
     *
     * @return boolean trueʾһ
     * @throws SQLException
     */
    public boolean hasNext() throws SQLException
    {
        return !rs.isLast() && !rs.isAfterLast() && (rs.getRow() !=0 || rs.isBeforeFirst());
    }

    /**
     * ָλǷвѯ
     *
     * @param index ѯ
     * @return boolean trueʾвѯ
     * @throws SQLException
     */
    public boolean isElementExist(int index) throws SQLException
    {
        if(index < 0 ) throw new IndexOutOfBoundsException("ָԽ!");
        //ĵǰλϢ
        this.currPosition();
        //ResultSet1ʼ
        boolean isExist = rs.absolute(index + 1);
        //ظղŵλ
        this.moveToCurrPosition();
        return isExist;
    }

    /**
     * αŵָλ,java.sql.ResultSet.absolute(int)
     *
     * @param index ָλã0ʼ
     * @return boolean trueʾɹ
     * @throws SQLException
     */
    public boolean absolute(int index) throws SQLException
    {
        if(index < 0 ) throw new IndexOutOfBoundsException("ָԽ!");
        //ResultSet1ʼ
        return rs.absolute(index + 1);
    }

    /**
     * αŵѯResultSetǰ
     *
     * @throws SQLException
     */
    public void beforeFirst() throws SQLException
    {
        rs.beforeFirst();
    }

    /**
     * αŵѯĵһ,java.sql.ResultSet.first()
     *
     * @return boolean trueʾƶɹ
     * @throws SQLException
     */
    public boolean first() throws SQLException
    {
        return rs.first();
    }

    /**
     * αŵѯһ,java.sql.ResultSet.last()
     *
     * @return boolean trueʾƶɹ
     * @throws SQLException
     */
    public boolean last() throws SQLException
    {
        return rs.last();
    }

    /**
     * ȡѯĴС,java.util.List.size()
     *
     * @return size ѯĴС
     * @throws SQLException
     */
    public int size() throws SQLException
    {
        //ĵǰλϢ
        this.currPosition();
        rs.last();
        int size = rs.getRow();
        //ظղŵλ
        this.moveToCurrPosition();
        return size;
    }

    /**
     * ṩһԱѯĶ󣬹java.util.List.iterator()
     *
     * @return DataListIterator ԱѯĶ
     * @throws Exception
     */
    public DataListIterator iterator() throws Exception
    {
        return new ResultSetDataListIterator(this);
    }

    /**
     * helperResultSetĵǰλϢmoveToCurrPosition()ʹá
     * @throws SQLException
     * @see moveToCurrPosition()
     */
    private void currPosition() throws SQLException
    {
        this.currIsBefore = rs.isBeforeFirst();
        this.currIsAfter = rs.isAfterLast();
        this.currIndex = rs.getRow();
    }

    /**
     * helperResultSetղŵλácurrPosition()ʹá
     * @throws SQLException
     * @see currPosition()
     */
    private void moveToCurrPosition() throws SQLException
    {
        if(this.currIsBefore)   rs.beforeFirst();
        else if(this.currIsAfter)   rs.afterLast();
        else if(this.currIndex != 0)    rs.absolute(this.currIndex);
    }
}