package org.softme.database.datalist;

import java.sql.SQLException;

/**
 * ResultSetDataListChunkʵDataListӿڣResultSetʹá
 *
 * ʾһѯResultSet͵һӼ
 * @author Michael Zeng
 * @version 1.0 September 23, 2002
 */
public class ResultSetDataListChunk implements DataList
{
    private ResultSetDataList dl = null;
    private int start = 0, count = 0, indexOfChunk = -1;

    /**
     * package캯
     *
     * @param _dl ȫļ,_dl.size()0
     * @param _start ʼλã0ʼ,ֵ_dl.size() - 1
     * @param _count Ӽĸ1ʼ
     * @throws Exception
     */
    ResultSetDataListChunk(DataList _dl, int _start, int _count)
            throws Exception
    {
        dl = (ResultSetDataList)_dl;
        start = Math.abs(_start);
        count = Math.abs(_count);
        if(dl.size() == 0)
            throw new Exception("ҪĽΪգ");
        if(start >= dl.size())
            throw new Exception("ʼλôڽĴС");
        if(start + count > dl.size())
            count = dl.size() - start;
    }

    /**
     * ȡָλòѯӼеֵֶŵһַвء
     * java.util.List.get(int)
     *
     * @param index ѯӼ
     * @return String[] еֵֶ
     *
     * @throws SQLException
     */
    public String[] get(int index) throws SQLException
    {
        if(index <0 || index >= count)
            throw new IndexOutOfBoundsException("ָԽ!");

        String[] value =  dl.get(start + index);
        indexOfChunk = index;
        return value;
    }

    /**
     * ѯӼǷΪռ
     *
     * @return boolean trueʾռ
     * @throws SQLException
     */
    public boolean isEmpty() throws SQLException
    {
        if(count == 0)
            return true;
        else
            return false;
    }

    /**
     * Ƿһѯ
     *
     * @return boolean trueʾһ
     */
    public boolean hasNext()
    {
        return (indexOfChunk + 1 < count);
    }

    /**
     * ָλǷвѯ
     *
     * @param index ѯ
     * @return boolean trueʾвѯ
     * @throws SQLException
     */
    public boolean isElementExist(int index) throws SQLException
    {
        if(index >= count)
            return false;
        else
            return dl.isElementExist(start + index);
    }

    /**
     * αŵָλ,java.sql.ResultSet.absolute(int)
     *
     * @param index ָλã0ʼ
     * @return boolean trueʾɹ
     * @throws SQLException
     */
    public boolean absolute(int index) throws SQLException
    {
        if(index >= count)
            return false;
        boolean isSuccess = dl.absolute(start + index);
        //ɹı䵱ǰchunk
        if(isSuccess)   indexOfChunk = index;
        return isSuccess;
    }

    /**
     * αŵѯӼChunkǰ
     *
     * @throws SQLException
     */
    public void beforeFirst() throws SQLException
    {
        indexOfChunk = -1;
        //start == 0ʾӸϵʼλÿʼ
        if(start == 0)
            dl.beforeFirst();
        else
            dl.absolute(start - 1);
    }

    /**
     * αŵѯӼĵһ,java.sql.ResultSet.first()
     *
     * @return boolean trueʾƶɹ
     * @throws SQLException
     */
    public boolean first() throws SQLException
    {
        return dl.absolute(start);
    }

    /**
     * αŵѯӼһ,java.sql.ResultSet.last()
     *
     * @return boolean trueʾƶɹ
     * @throws SQLException
     */
    public boolean last() throws SQLException
    {
        return dl.absolute(start + count -1);
    }

    /**
     * ȡѯӼĴС,java.util.List.size()
     *
     * @return size ѯӼĴС
     */
    public int size()
    {
        return count;
    }

    /**
     * ṩһԱѯĶ󣬹java.util.List.iterator()
     *
     * @return DataListIterator ԱѯĶ
     * @throws Exception
     */
    public DataListIterator iterator() throws Exception
    {
        return new ResultSetDataListIterator(this);
    }

}