package org.softme.database.datalist;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * PageʵDataListHandler
 *
 * ڲResultSetDataList󣬶Բѯзҳʾڽʾڼ䣬
 * ݿConnectionͽResultSetûйرա
 * ʹ÷
 * <pre>
 *              int index = 4, count = 10;//ʾ514¼
 *              Connection conn = Pool.getConnection();
 *              //(1)ʹһQueryDAOľʼҳ
 *              ResultSetQueryDAO dao = new ResultSetQueryDAO();
 *              ResultSetPage page = new ResultSetPage(conn, dao);
 *
 *              //(2)ֱʹһResultSetʼҳ
 *              //ResultSet rs = ...;
 *              //ResultSetPage page = new ResultSetPage(conn, rs);
 *
 *              //Ҫʾĵǰҳchunk
 *              DataList chunk = page.getListChunk(index, count);
 *              //ǰҳǰǷм¼,ʾPRVEIOUSNEXTť
 *              boolean hasPrevious = page.hasPrevious();
 *              boolean hasNext = page.hasNext();
 *              //ʾǰҳļ¼
 *              DataListIterator it = chunk.iterator();
 *              while (it.hasNext())
 *              {
 *                  String[] valuesOfRow = it.next();
 *                  for(int i = 0; i < valuesOfRow.lengtn; i++)
 *                      System.out.println(valuesOfRow[i]);
 *              }
 *
 * </pre>
 *
 * @author Michael Zeng
 * @version 1.0 September 23, 2002
 *
 * @see QueryDAO
 * @see DataListIterator
 */
public class ResultSetPage implements DataListHandler
{
    private Connection conn = null;
    private ResultSet rs = null;
    private ResultSetDataList dl = null;
    private RowMapper mapper = null;
    private QueryDAO dao = null;
    private int indexOfDataList = 0, countPerPage = 0;

    /**
     * 캯ṩڲѯDAO
     *
     * @param conn ݿ
     * @param dao ڲѯDAO
     * @throws SQLException
     *
     */
    public ResultSetPage(Connection conn, QueryDAO dao) throws SQLException
    {
        this.conn = conn;
        //ʹʹDAOѯ
        this.rs = (ResultSet)dao.doQuery(conn);
        initiateDataList();
    }

    /**
     * 캯ֱṩѯĽ
     *
     * @param conn ݿ
     * @param rs ѯĽ
     * @throws SQLException
     */
    public ResultSetPage(Connection conn, ResultSet rs) throws SQLException
    {
        this.conn = conn;
        this.rs = rs;
        initiateDataList();
    }

    /**
     * õѯֶ
     *
     * @return String[] ֶ
     */
    public String[] getColumns()
    {
        return mapper.getRowColumns();
    }

    /**
     * õѯһӼ
     *
     * @param startIndex Ӽʼλã 0ʼ
     * @param count Ӽĸ
     * @return Datalist һӼ
     * @throws Exception
     */
    public DataList getListChunk(int startIndex, int count) throws Exception
    {
        if(dl == null)
            throw new Exception("ûִвѯ߲ѯ̳쳣");

        indexOfDataList = Math.abs(startIndex);
        countPerPage = Math.abs(count);
        return new ResultSetDataListChunk(dl, indexOfDataList, countPerPage);
    }

    /**
     * ȡѯĴС,java.util.List.size()
     *
     * @return size ѯĴС
     * @throws SQLException
     */
    public int size() throws SQLException
    {
        if(dl == null)
            throw new SQLException("ûִвѯ߲ѯ̳쳣");
        return dl.size();
    }

    /**
     * ӼǰǷвѯ
     *
     * @return boolean trueʾǰ滹вѯ
     */
    public boolean hasPrevious()
    {
        if(indexOfDataList == 0)
            return false;
        else
            return true;
    }

    /**
     * ӼĺǷвѯ
     *
     * @return boolean trueʾ滹вѯ
     * @throws SQLException
     */
    public boolean hasNext() throws SQLException
    {
        if(indexOfDataList + countPerPage >= dl.size())
            return false;
        else
            return true;
    }

    /**
     * رն
     * @throws SQLException
     */
    public void close() throws SQLException
    {
        if(rs != null)
        {
            rs.close();
            rs = null;
        }
        mapper = null;
    }

    /**
     * helperӡ䣬ɰƵResultSetDataList
     *
     * @throws SQLException
     */
    private void initiateDataList() throws SQLException
    {
        //ӡ䣬ɰƵResultSetDataList
        mapper = new ResultSetRowMapper(rs);
        dl = new ResultSetDataList(mapper, conn, rs);
    }

}