package org.softme.webpm.info.project;

import java.sql.ResultSet;
import java.util.Iterator;

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * <p>Ŀӿ
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public abstract class ProjectFactory {
    private static Object initLock = new Object();
    private static ProjectFactory prjFactory = null;
    private static String className = "org.softme.webpm.info.project.ProjectFactoryImp";

    public static ProjectFactory getInstance(){
        if (prjFactory == null) {
            synchronized(initLock) {
                if (prjFactory == null) {
                    try {
                        String classNameProp = WebPMConfig.getProperty("ProjectFactoryImp.className");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);
                        prjFactory = (ProjectFactory)c.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load ProjectFactory class: "
                            + className + ". \n WebPM cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return prjFactory;
    }

    /**
     * ĿŶȡĿ
     * @param pID  Ŀ
     */
    public abstract Project getProject(int pID) throws ProjectNotFoundException;
    
    /**
     * ĿƶȡĿ
     * @param pName  Ŀ
     */
    public abstract Project getProject(String pName) throws ProjectNotFoundException;
        
    /**
     * Ŀ
     */
    public abstract Project createProject();
        
    /**
     * Ŀ
     * @param pPrjName  Ŀ
     * @param pPrjAuthor Ŀ
     * @param pPrjKeywords Ŀؼ
     * @param pPrjDesc Ŀ
     */
    public abstract Project createProject (String pPrjName, 
            String pPrjAuthor,
            String pPrjKeywords,
            String pPrjDesc) 
            throws ProjectAlreadyExistsException ;
       
    /**
     * ݿȡĿϢ
     * @param pRS ĿϢĽ
     */     
    public abstract Project loadProjectFromResultSet(ResultSet pRS);
        
    /**
     * ȡеĿб
     */     
    public abstract Iterator getAllProjects();    
}
