package org.softme.webpm.info.project;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.Iterator;

import org.softme.webpm.info.user.UserNotFoundException;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.DateTimeUtility;
import org.softme.webpm.utility.StringUtility;

/**
 * <p> Ŀӿʵ
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */


public class ProjectImp implements Project  {
	protected int gID = -1;
	protected String gName,gKeywords,gDescription,gAuthor, gCreateDate, gUpdateDate;
	
	protected int gFlag = 0;
	protected ProjectMemberFactory pmf = ProjectMemberFactory.getInstance();
	
	//// 캯
	ProjectImp() { }

	/* Get/Set Project ID
	 */
	public int getProjectID() {
		return gID;
	}

	public void setProjectID(int pid) {
		this.gID = pid;
	}

	// Ŀ
	public void setProjectName(String pProjectName) {
		this.gName = pProjectName;
	}
	public String getProjectName() {
		return this.gName;
	}
	
	// ؼ
	public void setKeywords(String pKeywords) {
		 this.gKeywords = pKeywords;
	}
	public String getKeywords(){
		return this.gKeywords;
	};
	
	// ȡü
	public String getDescription() {
		return this.gDescription;
	}
	public void setDescription(String pDesc) {
		this.gDescription = pDesc;
	}
	
	// : 
	public String getAuthor(){
		return this.gAuthor;	
	}
	public void setAuthor(String pAuthor){
		this.gAuthor = pAuthor;
	}
	
	// ԣʱ
	public String getCreateDate(){
		return this.gCreateDate;
	}
	public void setCreateDate(String pCreateDate) {
		this.gCreateDate = pCreateDate;
	}
	
	// ԣ޸ʱ
	public String getUpdateDate(){
		return this.gUpdateDate;
	}
	public void setUpdateDate(String pUpdateDate){
		this.gUpdateDate = pUpdateDate;	
	}
	
	// ñ־
	public void setFlag(int pFlag) {
		this.gFlag= pFlag;
	}

	// ȡñ־
	public int getFlag() {
		 return this.gFlag;
	}
	
	// 浽ݿ
	public boolean save() {
		if (this.gID < 0) {			
			return this.insertToDB();	
		}
		else{
			return this.modifyToDB();
		}
	}

	// ½ݿ
	private boolean insertToDB() {
        String INSERT_PROJECT = "INSERT INTO t_webpm_project (fprojectname, fkeywords, fdescription, fauthor, fcreatedate, fupdatedate, fflag) VALUES (?,?,?,?,?,?,?) ";
		
		this.gCreateDate =DateTimeUtility.getCurrentDateTime() ;
        this.gUpdateDate =gCreateDate;
        
        PreparedStatement pstmt=null;
        Connection conn=null;
		boolean rtn = false;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(INSERT_PROJECT) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gName)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gKeywords));
            pstmt.setString(3,StringUtility.encodeMemory2DB(gDescription)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gAuthor)) ;
            pstmt.setString(5,gCreateDate) ;
            pstmt.setString(6,gUpdateDate) ;
            pstmt.setInt(7,gFlag) ;
            
            pstmt.executeUpdate() ;
            
            // ĿΪԱ
            this.addMember(this.gAuthor);
            
			rtn = true;
			        
        }catch(Exception e){
            WebPMConfig.logger.error(e);
            rtn = false;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
		return rtn;
    }

    public void modifyFlag(){
        String UPDATE_PROJECT = "UPDATE t_webpm_project SET fflag=? WHERE fid=?";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_PROJECT) ;
            pstmt.setInt(1 ,gFlag) ;
            pstmt.setInt(2,gID) ;
            pstmt.executeUpdate() ;
        }catch(SQLException e){
            Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }

	private boolean modifyToDB(){
        String UPDATE_PROJECT = "UPDATE t_webpm_project SET fprojectname=?,fkeywords=?,fdescription=?,fauthor=?, fcreatedate=?,fupdatedate=?,fflag=? WHERE fid=?";
        
        gUpdateDate=DateTimeUtility.getCurrentDateTime();        
        PreparedStatement pstmt=null;
        Connection conn=null;
        boolean rtn = true;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_PROJECT) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gName)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gKeywords));
            pstmt.setString(3,StringUtility.encodeMemory2DB(gDescription)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gAuthor)) ;
            pstmt.setString(5,gCreateDate) ;
            pstmt.setString(6,gUpdateDate) ;
            pstmt.setInt(7,gFlag) ;
            pstmt.setInt(8,gID) ;
            
            pstmt.executeUpdate() ;

        }catch(SQLException e){
            WebPMConfig.logger.error(e);
            rtn = false;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }

        return rtn;
    }
	
	/**
	 * <p> ĿԱ
	 * @param pMemberName ĿԱû
	 */
	 public boolean addMember(String pMemberName) throws UserNotFoundException,
	 		ProjectMemberAlreadyExistsException {
	 	pmf.addProjectMember(this.gID, pMemberName);
		return true;	 	
	 }
	 
	/**
	 * <p> ĿԱ
	 * @param pMemberName ĿԱû
	 * @param pMemberFlag ĿԱû״̬
	 */
	 public boolean addMember(String pMemberName, int pMemberFlag) throws UserNotFoundException,
	 		ProjectMemberAlreadyExistsException {
	 	ProjectMember member = pmf.addProjectMember(this.gID, pMemberName);
	 	member.setMemberFlag(pMemberFlag);
	 	member.save();
		return true;	 	
	 }

	 /**
	  * <p> ĿԱ
	  * @param pMemberName ĿԱû
	  */
	 public ProjectMember getMember(String pMemberName) throws UserNotFoundException,
	 		MemberNotFoundInProjectException {
	 	
	 	return pmf.getProjectMember(this.gID, pMemberName);
	 }
	 
	 /**
	  * <p> ɾĿԱ
	  * @param pMemberName ĿԱû
	  */
	 public boolean removeMember(String pMemberName) throws
	 		UserNotFoundException,
	 		MemberNotFoundInProjectException {
	 	ProjectMember member = pmf.getProjectMember(this.gID, pMemberName);
	 	member.setMemberFlag(-1);	// ɾ	 	
	 	return member.save();	 	 
	 }
	 
	 /**
	  * <p> ĿԱб
	  */
	 public Iterator getAllMembers() {
	 	return pmf.getAllMembers(this.gID);
	}
}
