package org.softme.webpm.info.project;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Iterator;

import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserNotFoundException;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * <p>Ŀû
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public abstract class ProjectMemberFactory {
    private static Object initLock = new Object();
    private static ProjectMemberFactory pmf = null;
    private static String className = "org.softme.webpm.info.project.ProjectMemberFactoryImp";

    public static ProjectMemberFactory getInstance(){
        if (pmf == null) {
            synchronized(initLock) {
                if (pmf == null) {
                    try {
                        String classNameProp = WebPMConfig.getProperty("ProjectMemberFactoryImp.className");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);
                        pmf = (ProjectMemberFactory)c.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load ProjectMemberFactory class: "
                            + className + ". \n WebPM cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return pmf;
    }
		
	/**
     * ĿԱ
     */
    public abstract ProjectMember createProjectMember();

	/**	
	 * û󴴽ĿԱ
	 * @param pUser û	 
	 */	 
	public abstract ProjectMember createProjectMember(User pUser);
	
	/**
     * ĿԱ
     * @param pPrjID  Ŀ
     * @param pMemberName ĿԱ
     */
    public abstract ProjectMember createProjectMember (int pPrjID, String pMemberName)             
            throws UserNotFoundException, ProjectMemberAlreadyExistsException;
       
    /**
     * ݿȡĿϢ
     * @param pRS ĿϢĽ
     */     
    public abstract ProjectMember loadMemberFromResultSet(ResultSet pRs) 
    	throws UserNotFoundException,SQLException;

	/**
     * ûȡĿԱ
     * @param pPrjID  Ŀ
	 * @param pMemberName ĿԱ
     */
    public abstract ProjectMember getProjectMember(int pPrjID, String pMemberName) 
		throws UserNotFoundException, MemberNotFoundInProjectException;
    
    /**
     * ûΪĿԱ
     * @param pPrjID  Ŀ
	 * @param pMemberName ĿԱ
     */
    public abstract ProjectMember addProjectMember(int pPrjID, String pMemberName) 
		throws UserNotFoundException, ProjectMemberAlreadyExistsException;       
    
       
    /**
     * ȡеĿԱб
	 * @param pPrjID Ŀ
     */     
    public abstract Iterator getAllMembers(int pPrjID);    
}
