package org.softme.webpm.info.project;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;

import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserFactory;
import org.softme.webpm.info.user.UserNotFoundException;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.StringUtility;

/**
 * <p>Ŀû
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public class ProjectMemberFactoryImp extends ProjectMemberFactory {
	protected UserFactory uf = UserFactory.getInstance();
	
    /**
     * ĿԱ
     */
    public ProjectMember createProjectMember(){
    	return new ProjectMemberImp();	
    };
	
	/**	
	 * û󴴽ĿԱ
	 * @param pUser û	 
	 */	 
	public ProjectMember createProjectMember(User pUser){
		ProjectMember member = this.createProjectMember();
		
		member.setUserID(pUser.getUserID());
		member.setUserName(pUser.getUserName());
		member.setPassword(pUser.getPassword());
		member.setQuestion(pUser.getQuestion());
		member.setAnswer(pUser.getAnswer());
		member.setBirthday(pUser.getBirthday());
		member.setEmail(pUser.getEmail());
		member.setAddress(pUser.getAddress());
		member.setPhone(pUser.getPhone());
		member.setSex(pUser.getSex());
		member.setMemo(pUser.getMemo());
		member.setCreateDate(pUser.getCreateDate());
		member.setUpdateDate(pUser.getUpdateDate());		
		member.setFlag(pUser.getFlag());
		
		member.setMemberName(pUser.getUserName());
		
		return member;		
	}
	
	/**
     * ĿԱ
     * @param pPrjID  Ŀ
     * @param pMemberName ĿԱ
     */
    public ProjectMember createProjectMember (int pPrjID, String pMemberName) 
            throws UserNotFoundException, ProjectMemberAlreadyExistsException {
 		
 		// 
	 	if(pMemberName==null||pMemberName.length()<=0){
	 		return null;
	 	}
	 	try{
	 		this.getProjectMember(pPrjID, pMemberName);
	 		throw new ProjectMemberAlreadyExistsException();
	 	} catch (MemberNotFoundInProjectException e){
	 		//Աڣ׼
	 	}	 	
	 	 
 		ProjectMemberImp member = (ProjectMemberImp) this.createProjectMember(uf.getUser(pMemberName));
 		member.setProjectID(pPrjID);
	 	member.setMemberID(-1);
	 	
	 	return member;	 			 	
    };
       
    /**
     * ݿȡĿϢ
     * @param pRS ĿϢĽ
     */     
    public ProjectMember loadMemberFromResultSet(ResultSet pRs) 
    		throws UserNotFoundException, SQLException {
    		
    	ProjectMember member = this.createProjectMember(uf.getUser(pRs.getString("fmembername")));
    	
    	member.setMemberID(pRs.getInt("fid"));
    	member.setProjectID(pRs.getInt("fprojectid"));
    	member.setMemberName(StringUtility.encodeDB2Memory(pRs.getString("fmembername")));
    	member.setMemberJoinDate(pRs.getString("fcreatedate"));
    	member.setMemberUpdateDate(pRs.getString("fupdatedate"));
    	member.setMemberFlag(pRs.getInt("fflag"));
    	
    	return (ProjectMember) member;	
    };

	/**
     * ûȡĿԱ
     * @param pPrjID  Ŀ
	 * @param pMemberName ĿԱ
     */
    public ProjectMember getProjectMember(int pPrjID, String pMemberName)     
		throws UserNotFoundException, MemberNotFoundInProjectException{
			
		String SELECT_PROJECT_MEMBER = "SELECT * FROM t_webpm_project_member WHERE fprojectid=? AND fmembername=?";
        
        Connection conn = null;
        PreparedStatement pst = null;
        ProjectMemberImp member = null;
        
        try{
        	conn = DBConnection.newInstance();
        	pst = conn.prepareStatement(SELECT_PROJECT_MEMBER);
        	pst.setInt(1, pPrjID);
        	pst.setString(2, StringUtility.encodeMemory2DB(pMemberName));
        	ResultSet rs = pst.executeQuery();
        	if (rs.next()) {
        		member = (ProjectMemberImp) this.loadMemberFromResultSet(rs);
        	} else {
        		throw new MemberNotFoundInProjectException();
        	}
        	
        } catch(SQLException e) {
        	WebPMConfig.logger.error(e);
        	return null;
        } finally {
        	DBConnection.closeConnection(pst, conn);
        }
	 	return (ProjectMember) member;	
	};
    
    /**
     * ûΪĿԱ
     * @param pPrjID  Ŀ
	 * @param pMemberName ĿԱ
     */
    public ProjectMember addProjectMember(int pPrjID, String pMemberName) 
		throws UserNotFoundException, ProjectMemberAlreadyExistsException{
			
		ProjectMember member = this.createProjectMember(pPrjID, pMemberName);
		
		if (member.save()){
			return member;
		}
		
		return null;		
	};  
		     
    
       
    /**
     * ȡеĿԱб
	 * @param pPrjID Ŀ
     */     
    public Iterator getAllMembers(int pPrjID){
    	String SELECT_ALL_PROJECTMEMBER = "SELECT * FROM t_webpm_project_member WHERE fprojectid=?";
	 	
	 	Connection conn = null;
	 	PreparedStatement pst = null;
	 	ProjectMember member = null;	 	
	 	ArrayList memberList = new ArrayList();
	 	
	 	try{
	 		conn = DBConnection.newInstance();
	 		pst = conn.prepareStatement(SELECT_ALL_PROJECTMEMBER);
	 		pst.setInt(1, pPrjID);
	 		ResultSet rs = pst.executeQuery();
	 		while( rs.next()){
	 			member = this.loadMemberFromResultSet(rs);
	 			memberList.add(member);
	 		}
	 	} catch (Exception e){
	 		e.printStackTrace();
	 		return null;	 		
	 	} finally{
	 		DBConnection.closeConnection(pst,conn);	
	 	}
	 	return memberList.iterator();		 
    };    
}
