package org.softme.webpm.info.project;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

import org.softme.webpm.info.user.UserImp;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.DateTimeUtility;

/**
 * <p> ĿԱʵ
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public class ProjectMemberImp extends UserImp
			implements ProjectMember{	
			
	protected int gMemberID, gMemberFlag, gProjectID;
	protected String gMemberName, gMemberJoinDate, gMemberUpdateDate;
	
	/**
	 * ProjectMember ID
	 */
	public int getMemberID(){
		return this.gMemberID;
	};
	
	public void setMemberID(int pid){
		this.gMemberID = pid;	
	};
		
	/**
	 * Project ID
	 */ 
	public int getProjectID(){
		return this.gProjectID;	
	};	
	public void setProjectID(int pPrjID){
		this.gProjectID = pPrjID;
	};
	
	/**
	 * ProjectMember Name
	 */ 
	public String getMemberName(){
		return this.gMemberName;	
	};
	public void setMemberName(String pName){
		this.gMemberName = pName;	
	};	
			
	/**
	 * ĿԱʱ
	 */
	public String getMemberJoinDate(){
		return this.gMemberJoinDate;	
	};	
	public void setMemberJoinDate(String pJoinDate){
		this.gMemberJoinDate = pJoinDate;	
	};
		
	/**
	 * ĿԱʱ
	 */
	public String getMemberUpdateDate(){
		return this.gMemberUpdateDate;	
	};	
	public void setMemberUpdateDate(String pUpdateDate){
		this.gMemberUpdateDate = pUpdateDate;	
	};
		
	// ñ־
	public int getMemberFlag(){
		return this.gMemberFlag;	
	};
	public void setMemberFlag(int pFlag){
		this.gMemberFlag = pFlag;	
	};	
		
	/**
	 * 
	 */
	public ProjectMemberImp(int pPrjID, String pMemberName) {
		this.gProjectID = pPrjID;
		this.gMemberName = pMemberName;
		this.gMemberFlag = 0;
		this.gMemberID = -1;
		this.gMemberJoinDate = DateTimeUtility.getCurrentDateTime();
		this.gMemberUpdateDate = this.gMemberJoinDate;
	}

	/**
	 * Constructor ProjectMemberImp.
	 */
	public ProjectMemberImp() {
	}

	
	private boolean insertToDB(){		
	 	String INSERT_PROJECT_MEMBER = "INSERT INTO t_webpm_project_member (fprojectid, fmembername,fcreatedate,fupdatedate,fflag) VALUES(?,?,?,?,?)";
	 	
	 	String sCreateDate, sUpdateDate;
	 	sCreateDate = sUpdateDate = DateTimeUtility.getCurrentDateTime();
        
        PreparedStatement pst = null;
        Connection conn = null;
        boolean rtn = false;
        try{
        	conn = DBConnection.newInstance();
        	pst = conn.prepareStatement(INSERT_PROJECT_MEMBER);
        	pst.setInt(1, this.gProjectID);
        	pst.setString(2, this.gMemberName);
        	pst.setString(3, sCreateDate);
        	pst.setString(4, sUpdateDate);
        	pst.setInt(5, 0);	// ȱʡ־Ϊ 0
        	pst.executeUpdate();        	
        	rtn = true;        	
        } catch (SQLException e) {
        	rtn = false;
        	WebPMConfig.logger.error(e);
        } finally {
       		DBConnection.closeConnection(pst,conn); 	
        }
	 	return rtn; 			
	}
	
	private boolean modifyToDB(){
		String UPDATE_PROJECT_MEMBER = "UPDATE t_webpm_project_member SET fupdatedate=?,fflag=? WHERE fid=?";
        
        gUpdateDate=DateTimeUtility.getCurrentDateTime();        
        PreparedStatement pstmt=null;
        Connection conn=null;
        boolean rtn = true;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_PROJECT_MEMBER) ;
            pstmt.setString(1,this.gUpdateDate) ;
            pstmt.setInt(2,this.gMemberFlag);            
            pstmt.setInt(3,this.gMemberID) ;
            
            pstmt.executeUpdate() ;

        }catch(SQLException e){
            WebPMConfig.logger.error(e);
            rtn = false;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }

        return rtn;	
	}
	
	/**
	 * 浽ݿ
	 */ 
	public boolean save()
	{
		if (this.gMemberID < 0) {			
			return this.insertToDB();	
		}
		else{
			return this.modifyToDB();
		}
	};
}
