package org.softme.webpm.info.project;

import org.apache.regexp.RE;
import org.softme.webpm.jwiki.tagProcessor.TagProcessor;
import org.softme.webpm.pub.WebPMConfig;

/**
 * Title:
 * Description:
 * Copyright:    Copyleft (c) 2002
 * Company:      Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public class ProjectTagProcessor implements TagProcessor{
    private ProjectFactory pf = ProjectFactory.getInstance() ;
    
    public ProjectTagProcessor() {
    }
    
    public String process(String pStr){
//        CodeTransform transform=new CodeTransform();
        try {

            RE re=new RE("\\[project=(.+?)\\]");

            while(re.match(pStr) ){
                String projectInfo="<hr>";
                String x1=re.getParen(1);
                try{

                    Project prj = pf.getProject(x1) ;
                    projectInfo=projectInfo +
                    		"Ŀ:" + prj.getProjectID() + "<br>" +  
						    "Ŀ:" + prj.getProjectName() + "<br>" + 
						    "ؼ:" + prj.getKeywords() + "<br>" + 
						    ":" + prj.getAuthor() + "<br>" + 
						    "ʱ:" + prj.getCreateDate() + "<br>" + 
						    "ʱ:" + prj.getUpdateDate() + "<br>" + 
						    ":" + prj.getDescription() + "<br>";

                }catch(ProjectNotFoundException e){
                    projectInfo = projectInfo+"Ŀ";
                    WebPMConfig.logger.error(e);
                }
                x1= projectInfo+"<hr>";
                projectInfo="";
                //Ӳǩ
                x1="[myno]"+x1+"[/myno]";
                
                pStr=re.subst(pStr,x1,RE.REPLACE_FIRSTONLY ) ;

            }
            return pStr;
        }catch (Exception e) {
            WebPMConfig.logger.error(e);
            return e.toString();
        }

    }
}