package org.softme.webpm.info.user;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Iterator;

import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.StringUtility;

/**
 * <p> û
 * CopyLeft (l) 2001-2002 by Softme Studio
 * @author BrokenDoor
 * @version 1.2 BrokenDoor
 * @version 1.0 ̤
 */

public class UserFactoryImp extends UserFactory {
	
	// ݿȡ
	private User loadUserFromResultSet(ResultSet pRs) throws SQLException {
		User user = this.createUser();
		
	    user.setUserID(pRs.getInt("fid"));
        user.setUserName(StringUtility.encodeDB2Memory(pRs.getString("fusername"))) ;
        user.setPassword(StringUtility.encodeDB2Memory(pRs.getString("fpassword"))) ;
        user.setQuestion(StringUtility.encodeDB2Memory(pRs.getString("fquestion"))) ;
        user.setAnswer(StringUtility.encodeDB2Memory(pRs.getString("fanswer"))) ;
        user.setEmail(StringUtility.encodeDB2Memory(pRs.getString("femail"))) ;
        user.setSex(StringUtility.encodeDB2Memory(pRs.getString("fsex"))) ;
        user.setBirthday(pRs.getString("fbirthday")) ;
        user.setPhone(StringUtility.encodeDB2Memory(pRs.getString("fphone"))) ;
        user.setAddress(StringUtility.encodeDB2Memory(pRs.getString("faddress"))) ;
        user.setMemo(StringUtility.encodeDB2Memory(pRs.getString("fmemo"))) ;
        user.setAddress(StringUtility.encodeDB2Memory(pRs.getString("faddress"))) ;
        user.setCreateDate(pRs.getString("fcreatedate"));
        user.setUpdateDate(pRs.getString("fupdatedate"));
        user.setFlag(pRs.getInt("fflag")) ;
        
        return user;
	}

	//жûǷ
	public User getUser( String pName) throws UserNotFoundException {
		// 
		if (pName==null||pName.length()<0) {
			return null;
		}
		String GET_USER_BY_NAME = "SELECT * FROM t_webpm_user where fusername=?";
		Connection conn = null;
        PreparedStatement pstmt = null;
        User existingUser = null;
        try{
			conn = DBConnection.newInstance() ;
            pstmt = conn.prepareStatement(GET_USER_BY_NAME) ;
        	pstmt.setString(1,StringUtility.encodeMemory2DB(pName)) ;
            ResultSet arRs = pstmt.executeQuery() ;
            if(arRs.next()){
                existingUser = this.loadUserFromResultSet(arRs) ;
            }else{
                throw new UserNotFoundException("UserManagerError: user not found..");
            }
        }catch(SQLException e){
            WebPMConfig.logger.error(e);
			throw new UserNotFoundException("UserManagerError: SQL Error.");
        }finally{
            DBConnection.closeConnection(pstmt,conn) ;
        }
        return existingUser;

	}

	//жûidǷ
	public User getUser( int pID) throws UserNotFoundException {
		// 
		if (pID<=0) {
			return null;
		}
		String GET_USER_BY_ID = "SELECT * FROM t_webpm_user where fid=?";
		Connection conn = null;
        PreparedStatement pstmt = null;
        User existingUser = null;
        try{
			conn = DBConnection.newInstance() ;
            pstmt = conn.prepareStatement(GET_USER_BY_ID) ;
        	pstmt.setInt(1,pID) ;
            ResultSet arRs = pstmt.executeQuery() ;
            if(arRs.next()){
                existingUser = this.loadUserFromResultSet(arRs) ;
            }else{
                throw new UserNotFoundException("UserManagerError: user not found..");
            }
        }catch(SQLException e){
            WebPMConfig.logger.error(e);
			throw new UserNotFoundException("UserManagerError: SQL Error.");
        }finally{
            DBConnection.closeConnection(pstmt,conn) ;
        }
        return existingUser;

	}
	
    public Iterator getAllUsers(){
      	String GET_ALL_USER="SELECT * FROM t_webpm_user ORDER BY fid desc";
      	Connection conn=null;
      	PreparedStatement pstmt=null;
      	User user=null;
      	ArrayList userList=new ArrayList();
      	try{
          	conn=DBConnection.newInstance() ;
          	pstmt=conn.prepareStatement(GET_ALL_USER) ;
          	ResultSet arRs=pstmt.executeQuery() ;
          	while(arRs.next()){
              	user = this.loadUserFromResultSet(arRs) ;
              	userList.add(user) ;
          	}
      	}catch(SQLException e){
          	WebPMConfig.logger.error(e);
      	}finally{
          	DBConnection.closeConnection(pstmt,conn) ;
      	}

      	return userList.iterator() ;
 	}

	public User createUser(){
		return new UserImp();
	}

	public boolean registerUser(User pUser) throws UserHasAlreadyExistsException{

        try{
            User uesr = this.getUser(pUser.getUserName()) ;
            throw new UserHasAlreadyExistsException();
        }catch(UserNotFoundException e){
            pUser.save()  ;
        }
        return true;
	}

    /**
     * ûб
     */
    public Iterator bestUsers(){
		Connection conn = null;
        PreparedStatement pstmt = null;


        ArrayList orderList=new ArrayList();
        final int MAX=20;
        final String USER_ARTICLE_ORDER="SELECT count(*) as fnumber,fauthor FROM t_wiki_article GROUP BY fauthor ORDER BY fnumber desc";
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(USER_ARTICLE_ORDER) ;
            ResultSet oRs=pstmt.executeQuery() ;
            int count=0;
            while(oRs.next() ){

                UserArticleNumber arNumber=new UserArticleNumber(StringUtility.encodeDB2Memory(oRs.getString("fauthor"))
                                                                ,oRs.getInt("fnumber"));

                orderList.add(arNumber) ;
                count++;
                if(count>=MAX) break;
            }

        }catch(Exception e){
            WebPMConfig.logger.error(e);
        }finally{
            DBConnection.closeConnection(pstmt,conn) ;
        }
        return orderList.iterator() ;
    }

} // class UserManager 's end