/**
 * $RCSfile: KeyIndex.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:25 $
 *
 * Copyright (C) 2001-2002 softme.org (Softme Studio). All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.jwiki;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Vector;

import org.softme.webpm.jwiki.tagProcessor.TagProcessor;
import org.softme.webpm.jwiki.tagProcessor.TagProcessorFactory;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.StringUtility;

/**
 * Wiki ؼ
 * @author 
 * @version 1.0
 */

public class KeyIndex {
  private static KeyIndex keyIndexInstance=null;
  private Vector keyList=new Vector();
  TagProcessorFactory tagFactory=TagProcessorFactory.getInstance() ;
  TagProcessor processor=tagFactory.getProcessor("html") ;
  private KeyIndex() {
      String GET_ALL_KEY="SELECT ftopic FROM t_wiki_article";
      Connection conn=null;
      PreparedStatement pstmt=null;
      String sTopic=null;
      try{
          //Debug.print("KeyIndex init...") ;
          WebPMConfig.logger.info("KeyIndex init...");
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(GET_ALL_KEY) ;
          ResultSet keyRs=pstmt.executeQuery() ;
          while(keyRs.next()){
              sTopic=StringUtility.encodeDB2Memory(keyRs.getString("ftopic"));
			  //Debug.println(sTopic);
              addKey(sTopic) ;

          }
          //Debug.println("OK!") ;
          WebPMConfig.logger.info("KeyIndex Inited!");
      }catch(Exception e){
//          Debug.println("False!") ;
//          Debug.println(e.toString()) ;
			WebPMConfig.logger.error(e);
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }

  }
  
  public static KeyIndex getInstance(){
     if(keyIndexInstance==null){
          keyIndexInstance=new KeyIndex();
         
      }
      
      return keyIndexInstance;      
  }

	public boolean isExist(String key){
		return keyList.contains(key);
	}
	public String addKey(String pKey){
		//ҳؼȽhtmlתٽжϹؼǷڣԶתhtmlٽж
		keyList.addElement(processor.process(pKey)) ;
		return pKey;
	}
  
 	public static void reload(){
 		keyIndexInstance = null;	
 		//Debug.print("KeyIndex released OK!") ; 
 		WebPMConfig.logger.info("KeyIndex released OK!");
  	}
}