package org.softme.webpm.jwiki.article;
import java.util.Iterator;

import org.softme.webpm.jwiki.exception.ArticleAlreadyExistsException;
import org.softme.webpm.jwiki.exception.ArticleAlreadyModifyException;
import org.softme.webpm.jwiki.exception.ArticleNotFoundException;
import org.softme.webpm.jwiki.exception.BodyNotChangeException;
import org.softme.webpm.jwiki.query.Query;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public abstract class ArticleFactory {
    private static Object initLock = new Object();
    private static String className = "org.softme.webpm.jwiki.article.ArticleFactoryImp";
    private static ArticleFactory arFactory = null;

    public static ArticleFactory getInstance(){
        if (arFactory == null) {
            synchronized(initLock) {
                if (arFactory == null) {
                    try {
                        String classNameProp=WebPMConfig.getProperty("JWiki.ClassName.ArticleFactoryImp");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);
                        arFactory = (ArticleFactory)c.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load ArticleFactory class "
                            + className + ". Jwiki cannot function normally.");
                        //e.printStackTrace();
                        WebPMConfig.logger.error(e);
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return arFactory;

    }

	public static void closeInstance(){
		arFactory = null;		
	}   
	 
    public abstract Article createArticle(String pTopic,String pBody,String pAuthor) throws ArticleAlreadyExistsException;

    /**
     * һյArticle
     */
    public abstract Article newArticle();
    /**
     * õ
     */
    public abstract Article getArticle(int pID) throws ArticleNotFoundException;

    public abstract Article getArticle(String pTopic) throws ArticleNotFoundException;

    public abstract Article getVersion(int pID) throws ArticleNotFoundException;

    /**
     * û
     */
    public abstract Iterator getArticleByUser(String pUserName) throws ArticleNotFoundException;

    /**
     * µ
     * @param pNewArticle Ҫݵ
     * @param pLastUpdateDate øڣжǷб༭ĳͻ
     */
    public abstract void updateArticleBody(Article pNewArticle,String pLastUpdateDate) throws ArticleAlreadyModifyException,BodyNotChangeException,ArticleNotFoundException;
    /**
     * µб
     */
    public abstract Iterator getRecentChanges();

    /**
     * ñݿеһƪ¸
     * param pBackupID  ݿµIDš
     */
    public abstract Article revert(int pBackupID);

    /**
     * һѯ
     * param pKey ѯ
     */
    public abstract Query createQuery(String pKey);

    /**
     * õһİ汾
     */
    public abstract Iterator getVersions(String pTopic);

    /**
     * ܻӭ
     */
    public abstract Iterator getActivePage();

    /**
     * ʵб
     */
    public abstract Iterator getRecentVisit();





}