package org.softme.webpm.jwiki.article;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;

import org.softme.webpm.jwiki.exception.NoVisitException;
import org.softme.webpm.jwiki.tagProcessor.TagProcessorFactory;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.DateTimeUtility;
import org.softme.webpm.utility.StringUtility;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleImp implements Article{
    protected String gTopic,gBody,gCreateDate,gAuthor,gMender,gUpdateDate;
    protected int gFlag,gID;
    protected VisitInfo visitInfo; //µķϢ

    public int getID(){
        return gID;
    }
    public String getTopic(){
        return gTopic;
    }
    public String getBody(){
        return gBody;
    }
    public String getAuthor(){
        return gAuthor;
    }
    public String getCreateDate(){
      return gCreateDate;
    }
    public String getUpdateDate(){
        return gUpdateDate;
    }
    public String getMender(){
        return gMender;
    }
    public int getFlag(){
        return gFlag;
    }

    public void setID(int pID){
        this.gID =pID;
    }
    public void setBody(String aBody){
        this.gBody =aBody;
    }
    public void setTopic(String aTopic){
        this.gTopic =aTopic;
    }
    public void setAuthor(String aAuthor){
        this.gAuthor =aAuthor;
    }
    public void setMender(String aMender){
        this.gMender =aMender;
    }
    public void setFlag(int aFlag){
        this.gFlag =aFlag;
    }
    public void setCreateDate(String aDate){
        this.gCreateDate =aDate;
    }
    public void setUpdateDate(String aUpdateDate){
        this.gUpdateDate =aUpdateDate;
    }

    public ArticleImp(){
    }

    public ArticleImp(String pTopic,String pBody,String pAuthor){
        this.gTopic =pTopic;
        this.gAuthor =pAuthor;
        this.gMender =pAuthor;
        this.gBody =pBody;
        this.gCreateDate =DateTimeUtility.getCurrentDateTime() ;
        this.gUpdateDate =gCreateDate;
        this.gFlag =Article.UNLOCK;
        insertToDB();
    }
    public String getWikiBody(){

       TagProcessorFactory tagFactory=TagProcessorFactory.getInstance() ;

       return tagFactory.processTags("\n" + gBody) ;
    }

    public Article modifyBody(){
        modifyBodyToDB();
        return this;
    }
    public VisitInfo getVisitInfo() throws NoVisitException{
        String SELECT_VISITOR="SELECT * FROM t_wiki_visitor WHERE ftopic=?";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(SELECT_VISITOR) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gTopic)) ;
            ResultSet oRs=pstmt.executeQuery() ;
            if(oRs.next()){
                visitInfo=new VisitInfo(StringUtility.encodeDB2Memory(oRs.getString("ftopic")),
                                        StringUtility.encodeDB2Memory(oRs.getString("fvisitor")) ,
                                        StringUtility.encodeDB2Memory(oRs.getString("fvisitdate")),
                                        oRs.getInt("fvisittimes"));
            }else{
                //return new VisitInfo(gTopic,"None");
                throw new NoVisitException();
            }
        }catch(SQLException e){
            //Debug.println(e.toString() ) ;
            WebPMConfig.logger.error(e);
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
        return visitInfo;
    }
    /**
     * һη
     * @param pVisit Ϣ
     */
    public void addOneRead(VisitInfo pVisit){
        String SELECT_VISITOR="SELECT ftopic FROM t_wiki_visitor WHERE ftopic=?";
        String UPDATE_VISITOR="UPDATE t_wiki_visitor SET fvisitdate=?,fvisittimes=fvisittimes+1,fvisitor=? WHERE ftopic=?";
        String INSERT_VISITOR="INSERT INTO t_wiki_visitor values (?,?,?,?)";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(SELECT_VISITOR) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(pVisit.getPageName())) ;
            ResultSet oRs=pstmt.executeQuery() ;
            if(oRs.next()){
                pstmt.close() ;
                pstmt=conn.prepareStatement(UPDATE_VISITOR) ;
                pstmt.setString(1,DateTimeUtility.getCurrentDateTime()) ;
                pstmt.setString(2,StringUtility.encodeMemory2DB(pVisit.getVisitor())) ;
                pstmt.setString(3,StringUtility.encodeMemory2DB(pVisit.getPageName())) ;
                pstmt.executeUpdate() ;
            }else{
                pstmt.close() ;
                pstmt=conn.prepareStatement(INSERT_VISITOR) ;
                pstmt.setString(1,StringUtility.encodeMemory2DB(pVisit.getPageName())) ;
                pstmt.setString(2,StringUtility.encodeMemory2DB(pVisit.getVisitor())) ;
                pstmt.setString(3,DateTimeUtility.getCurrentDateTime()) ;

                //ĬϷʴΪ0
                pstmt.setInt(4,1) ;
                pstmt.executeUpdate() ;
            }
        }catch(SQLException e){
//            Debug.println(e.toString() ) ;
            WebPMConfig.logger.error(e);
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }

    public void updateAllInfo(){

        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fbody=?,fmender=?,fcreatedate=?,fupdatedate=?,fauthor=?,fflag=? WHERE ftopic=?";
        gUpdateDate=DateTimeUtility.getCurrentDateTime();
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gBody)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gMender)) ;
            pstmt.setString(3,gCreateDate) ;
            pstmt.setString(4,gUpdateDate) ;
            pstmt.setString(5,StringUtility.encodeMemory2DB(gAuthor)) ;
            pstmt.setInt(6,gFlag) ;
            pstmt.setString(7,StringUtility.encodeMemory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
            //ָʱҲݱ.
            insertBackup(conn);
        }catch(SQLException e){
//            Debug.println(e.toString() ) ;
            WebPMConfig.logger.error(e);
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    public void changeFlag(int pFlag){
        gFlag=pFlag;
        modifyFlag();

    }

    private void modifyFlag(){
        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fflag=? WHERE ftopic=?";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setInt(1 ,gFlag) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
        }catch(SQLException e){
        	WebPMConfig.logger.error(e);
            //Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void modifyBodyToDB(){
        String UPDATE_ARTICLE="UPDATE t_wiki_article SET fbody=?,fmender=?,fupdatedate=? WHERE ftopic=?";
        gUpdateDate=DateTimeUtility.getCurrentDateTime();
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(UPDATE_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gBody)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gMender)) ;
            pstmt.setString(3,gUpdateDate) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gTopic)) ;
            pstmt.executeUpdate() ;
            insertBackup(conn);
        }catch(SQLException e){
        	WebPMConfig.logger.error(e);
//            Debug.println(e.toString() ) ;
        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void insertToDB(){
        String INSERT_ARTICLE="INSERT INTO t_wiki_article (ftopic,fbody,fauthor,fmender,fcreatedate,fupdatedate,fflag) values (?,?,?,?,?,?,?) ";
        PreparedStatement pstmt=null;
        Connection conn=null;
        try{
            conn=DBConnection.newInstance() ;
            pstmt=conn.prepareStatement(INSERT_ARTICLE) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gTopic)) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gBody));
            pstmt.setString(3,StringUtility.encodeMemory2DB(gAuthor)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gMender));
            pstmt.setString(5,gCreateDate) ;
            pstmt.setString(6,gUpdateDate) ;
            pstmt.setInt(7,gFlag) ;
            pstmt.executeUpdate() ;
            //ݲ,conn Ϊ֧
            insertBackup(conn);
        }catch(SQLException e){
        	WebPMConfig.logger.error(e);
//            Debug.println(e.toString()) ;

        }finally{
            DBConnection.closeConnection(pstmt,conn);
        }
    }
    private void insertBackup(Connection conn){
        String INSERT_ARTICLE_BACKUP="INSERT INTO t_wiki_articlebackup(ftopic,fbody,fauthor,fmender,fcreatedate,fupdatedate,fflag) values (?,?,?,?,?,?,?)";
        PreparedStatement pstmt=null;
        try{
            pstmt=conn.prepareStatement(INSERT_ARTICLE_BACKUP) ;
            pstmt.setString(1,StringUtility.encodeMemory2DB(gTopic) ) ;
            pstmt.setString(2,StringUtility.encodeMemory2DB(gBody) );
            pstmt.setString(3,StringUtility.encodeMemory2DB(gAuthor)) ;
            pstmt.setString(4,StringUtility.encodeMemory2DB(gMender));
            pstmt.setString(5,gCreateDate) ;
            pstmt.setString(6,gUpdateDate) ;
            pstmt.setInt(7,gFlag) ;
            pstmt.executeUpdate() ;
        }catch(SQLException e){
        	WebPMConfig.logger.error(e);
//            e.printStackTrace() ;
        }finally{
            try{
                pstmt.close() ;
            }catch(SQLException e){
            	WebPMConfig.logger.error(e);
//                e.printStackTrace() ;
            }
        }
  }
}