package org.softme.webpm.jwiki.article;

import org.softme.webpm.jwiki.exception.ArticleTemplateAlreadyExistsException;
import org.softme.webpm.jwiki.exception.ArticleTemplateNotFoundException;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * <p> ģ幤
 * Copyleft (l) 2001-2002 Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public abstract class ArticleTemplateFactory {
    private static Object initLock = new Object();
    private static String className = "org.softme.webpm.jwiki.ArticleTemplateFactoryImp";
    private static ArticleTemplateFactory atf = null;

    public static ArticleTemplateFactory getInstance(){
        if (atf == null) {
            synchronized(initLock) {
                if (atf == null) {
                    try {
                        String classNameProp=WebPMConfig.getProperty("ArticleTemplateFactoryImp.className");
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);
                        atf = (ArticleTemplateFactory)c.newInstance();
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load ArticleTemplateFactory class "
                            + className + ". WebPM Jwiki cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return atf;

    }

    public static void closeInstance(){
        atf = null;       
    }   
    
    public abstract ArticleTemplate createArticleTemplate(String pTopic, String pBody, String pAuthor)
        throws ArticleTemplateAlreadyExistsException;
        
    public abstract ArticleTemplate getArticleTemplate(String pTopic)
        throws ArticleTemplateNotFoundException;
}