package org.softme.webpm.jwiki.query;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Iterator;

import org.softme.webpm.jwiki.article.Article;
import org.softme.webpm.jwiki.article.ArticleImp;
import org.softme.webpm.pub.DBConnection;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.StringUtility;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class QueryImp implements Query {
    private String gKey;
    public QueryImp(String pKey) {
        gKey=pKey;
    }
    public Iterator searchTopic() {

      final String SEARCH_FROM_TOPIC="SELECT * FROM t_wiki_article WHERE ftopic like ?";
      return search(SEARCH_FROM_TOPIC);

    }
    public Iterator searchBody() {

      final String SEARCH_FROM_BODY="SELECT * FROM t_wiki_article WHERE fbody like ?";
      return search(SEARCH_FROM_BODY);
    }
  private Iterator search(String pSql){
      ArrayList searchResult=new ArrayList();
      Connection conn=null;
      PreparedStatement pstmt=null;
      String sTopic=null;
      Article article=null;
      try{
          conn=DBConnection.newInstance() ;
          pstmt=conn.prepareStatement(pSql) ;
          pstmt.setString(1,"%"+StringUtility.encodeMemory2DB(gKey)+"%") ;
          //Debug.print(sKey) ;
          ResultSet arRs=pstmt.executeQuery() ;
          while(arRs.next()){
              article=new ArticleImp();
              article.setTopic(StringUtility.encodeDB2Memory(arRs.getString("ftopic"))) ;
              article.setBody(StringUtility.encodeDB2Memory(arRs.getString("fbody"))) ;
              article.setAuthor(StringUtility.encodeDB2Memory(arRs.getString("fauthor"))) ;
              article.setCreateDate(StringUtility.encodeDB2Memory(arRs.getString("fcreatedate"))) ;
              article.setMender(StringUtility.encodeDB2Memory(arRs.getString("fmender"))) ;
              article.setFlag(arRs.getInt("fflag")) ;
              article.setID(arRs.getInt("fid")) ;

              searchResult.add(article) ;
          }
      }catch(Exception e){
//          e.printStackTrace() ;
//          Debug.println(e.toString()) ;
			WebPMConfig.logger.error(e);
      }finally{
          DBConnection.closeConnection(pstmt,conn) ;
      }
      return searchResult.iterator() ;

  }

}