package org.softme.webpm.jwiki.servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.jwiki.KeyIndex;
import org.softme.webpm.jwiki.article.Article;
import org.softme.webpm.jwiki.article.ArticleFactory;
import org.softme.webpm.jwiki.exception.ArticleAlreadyExistsException;
import org.softme.webpm.jwiki.exception.ArticleAlreadyModifyException;
import org.softme.webpm.jwiki.exception.ArticleNotFoundException;
import org.softme.webpm.jwiki.exception.BodyNotChangeException;
import org.softme.webpm.jwiki.tagProcessor.TagProcessorFactory;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.CookieUtility;
import org.softme.webpm.utility.DateTimeUtility;
import org.softme.webpm.utility.StringUtility;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class JwikiCortrol extends HttpServlet {
  	private static final String CONTENT_TYPE = "text/html; charset=GB2312";
  	
  	ArticleFactory arFactory = null;
  	
  	/**Initialize global variables*/
  	public void init() throws ServletException {
		arFactory = ArticleFactory.getInstance();
	}
  /**Process the HTTP Get request*/
  public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

      doPost(request,response);
  }
  public void doPost(HttpServletRequest request,HttpServletResponse response) throws ServletException, IOException {
      response.setContentType(CONTENT_TYPE);

	  PrintWriter out = response.getWriter();
      HttpSession session=request.getSession() ;
      //ArticleFactory arFactory=ArticleFactory.getInstance();
      Article ar = null;

	  String action=request.getParameter("action") ;
	  
      String sTopic=request.getParameter("topic");
      String sBody=request.getParameter("body");
      String sAuthor=request.getParameter("author") ;
      String sMender=request.getParameter("mender") ;
      
      String sPreview=request.getParameter("preview") ;      
	  String sPos = request.getParameter("position");
	  Debug.println("sPos=" + sPos);
	  String lastUpdateDate=request.getParameter("lastupdatedate") ;
      String urlRoot= WebPMConfig.getProperty("Site.DefaultRoot");
	  String url = urlRoot;
	  
	  sTopic=StringUtility.encodeRequest2Memory(sTopic) ;
      sBody=StringUtility.encodeRequest2Memory(sBody) ;
      sAuthor=StringUtility.encodeRequest2Memory(sAuthor) ;
	  sMender=StringUtility.encodeRequest2Memory(sMender);
      
	  if(sAuthor==null||sAuthor.equals("")||sAuthor.equals("null")){          
		  sAuthor=request.getRemoteAddr() ;
          //sAuthor="N/A";
      }
      if(sMender==null||sMender.equals("")||sMender.equals("null")){
          sMender=request.getRemoteAddr();
		  //sMender="N/A";		
      }

	//Debug.println(action);
	if (action.equalsIgnoreCase("comment")) {
		ar = processBody(sTopic, sBody, sMender, sPos);
		action = "save";
	}
	
	/* Added By BrokenDoor for Preview 
	 */
	if (sPreview!=null&&sPreview.equalsIgnoreCase("on"))
	{
		/**
		 * Added by brokendoor for comments -- 2002/08/26
		 */
		if (ar==null) {
		    ar=arFactory.newArticle();
	        ar.setTopic(sTopic);
			ar.setAuthor(sAuthor);
	        ar.setBody(sBody);
	 	}
        ar.setMender(sMender) ;
		ar.setCreateDate(lastUpdateDate);
		session.setAttribute("previewArticle",ar) ;
		url= urlRoot + "wiki_preview.jsp?action=" + action;
        response.sendRedirect(url);
	}else if(action.equalsIgnoreCase("reload")){
		// ¼
        WebPMConfig.reload();
        KeyIndex.reload();
        TagProcessorFactory.closeInstance();
       	response.sendRedirect(StringUtility.encodeMemory2Response(url));
    }
	/***********************************************************************/
	else if(action.equalsIgnoreCase("add")){
          try{
              arFactory.createArticle(sTopic ,sBody ,sAuthor) ;
              ar = arFactory.getArticle(sTopic);
              url= urlRoot + "jwiki.jsp?docid="+ar.getID();
              response.sendRedirect(url);
          }catch(ArticleAlreadyExistsException ex){
              Debug.println(ex.toString());
              ex.printStackTrace() ;
          }catch(ArticleNotFoundException ex) {
			  Debug.println(ex.toString());
          } 
      }
	else if(action.equalsIgnoreCase("save") ){
    	try{
  			/**
			 * Added by brokendoor for comments -- 2002/08/26
			 */
			if(ar==null) {
		    	ar=arFactory.getArticle(sTopic);
             	ar.setBody(sBody);              	
             	ar.setMender(sMender) ;
        	}        	
            arFactory.updateArticleBody(ar,lastUpdateDate) ;
            url= urlRoot + "jwiki.jsp?docid=" + ar.getID();
         }catch(ArticleAlreadyModifyException e){
              url=urlRoot + "jwiki.jsp?docid=0";
         }catch(BodyNotChangeException e){
              url=urlRoot + "jwiki.jsp?docid=" + ar.getID() ; //ֱӷ
         }catch(ArticleNotFoundException e){
              Debug.println(e.toString() ) ;
         }

		 //bug.println(url);

         if (!url.equals("")&&url!=null){
			 response.sendRedirect(url);
         } 
      }      
	  else if(action.equalsIgnoreCase("revert") ){
          int iID=Integer.parseInt(request.getParameter("id")) ;
          try{
              arFactory.getVersion(iID) ;
              arFactory.revert(iID) ;
              session.setAttribute("msg","汾:" + Integer.toString(iID) +" Ѿָ") ;
              url = urlRoot + "admin/";              
              response.sendRedirect(url);
          }catch(ArticleNotFoundException e){
              out.print(e.toString() ) ;
              session.setAttribute("msg",e.toString());
          }

      }
      else if(action.equalsIgnoreCase("lock")||action.equalsIgnoreCase("unlock") ){
          try{
 			  Article existingAr=arFactory.getArticle(sTopic) ;
              if(action.equalsIgnoreCase("lock")){
                  //arFactory.;
                  existingAr.changeFlag(Article.LOCK );
                  session.setAttribute("msg",sTopic+"  Ѿ") ;
              }
              if(action.equalsIgnoreCase("unlock")){
                 // arM.unlock(sTopic) ;
                  existingAr.changeFlag(Article.UNLOCK);
                  session.setAttribute("msg",sTopic+"  Ѿ") ;
              }

          }catch(ArticleNotFoundException e){
              out.print(e.toString()) ;
              session.setAttribute("msg",e.toString());
          }          
          url = urlRoot + "admin/";   
          response.sendRedirect(url);
          
      }
      else if(action.equals("languageset") ){
          String language=request.getParameter("language") ;
          String country=request.getParameter("country") ;
          ResourceBundle res=null;
          res=ResourceBundle.getBundle("org.softme.webpm.pub.Res",new Locale(language,country)) ;
          session.setAttribute("language",res) ;
          response.sendRedirect(url);
      }
      else if(action.equalsIgnoreCase("root")){
      	  String root = request.getParameter("root");
      	  CookieUtility.setCookie(response,"root", root);      	  
      	  response.sendRedirect(root);
 	  }    
  }
  /**Clean up resources*/
  public void destroy() {
  }
  
	private Article processBody(String sTopic, String sBody, String sMender, String sPos){
  		String sNewBody = "";
  		
 		Article ar = null; 		
 		
    	String sDateMark = DateTimeUtility.getCurrentDateTime() + " [" + sMender + "]\n";
  		Debug.println(sDateMark);
  		try{
 			 ar = arFactory.getArticle(sTopic) ;
	    }catch(ArticleNotFoundException e){
              Debug.println(e.toString() ) ;
              return null;
   		}
   		if ((sPos!=null)&&(sPos.equalsIgnoreCase("on"))){
  			sNewBody = sDateMark + sBody + "\n----\n" + ar.getBody();
  		}
  		else {
  			sNewBody = ar.getBody() + "\n----\n" + sDateMark +  sBody;
  		}
  		Debug.println(sNewBody);
  		ar.setBody(sNewBody);
  		ar.setMender(sMender) ;
  		
  		return ar;	
  	}
}