package org.softme.webpm.jwiki.tagProcessor;

/**
 * $RCSfile: TagProcessorFactory.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * JWikiǴ
 * @author ,BrokenDoor
 * @version 1.2.2
 */

public abstract class TagProcessorFactory {
    private static TagProcessorFactory tagFactory;
    private static String className="org.softme.webpm.jwiki.tagProcessor.TagProcessorFactoryImp";
    private static Object initLock = new Object();
    /**
     * ֻ֤һʵ
     */
    public static TagProcessorFactory getInstance(){
        if (tagFactory == null) {
            synchronized(initLock) {
                if (tagFactory == null) {
                    try {
                        String classNameProp=WebPMConfig.getProperty("JWiki.ClassName.TagProcessorFactoryImp") ;
                        if(classNameProp==null){
                            classNameProp=className;
                        }
                        Class c = Class.forName(classNameProp);

                        tagFactory = (TagProcessorFactory)c.newInstance();
                        //try {
                           // Method m = c.getMethod("getTagProcessorFactoryInstance", null);
                            //tagFactory=(TagProcessorFactory)m.invoke(tagFactory,null);
                        //}
                        //catch (NoSuchMethodException nsme) {System.out.print(nsme.toString()) ; }
                    }
                    catch (Exception e) {
                        Debug.println("Failed to load TagProcessorFactory class "
                            + className + ". Jwiki cannot function normally.");
                        e.printStackTrace();
                        return null;
                    }
                }
            }//end synchronized
        }//end if
        return tagFactory;

    }
    
	public static void closeInstance(){
		tagFactory = null;
	};
	
    public abstract String processTags(String pBody);

    public abstract TagProcessor getProcessor(String pProcessorName);


}