/**
 * $RCSfile: TagProcessorFactoryImp.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.jwiki.tagProcessor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import org.jdom.Element;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * Ǵ๤ʵ
 * @author 
 * @version 1.0
 */

public class TagProcessorFactoryImp extends TagProcessorFactory{
    private static TagProcessorFactory tagFactoryInstance=null;
    
    private static String processorMap = "JWiki.processor";
    
    private HashMap processors=new HashMap();
    private ArrayList processList=new ArrayList();
    public TagProcessorFactoryImp() {
        loadProcessors();
    }
    
    public  String processTags(String pBody){

        NoWikiTagProcessor noProcessor=null;
        ArrayList noProcessors=new ArrayList();
        for(int i=0;i<processList.size() ;i++){
            TagProcessor processor=(TagProcessor)processList.get(i);
            if(processor instanceof NoWikiTagProcessor){
                noProcessor=(NoWikiTagProcessor)processor;
                pBody=noProcessor.split(pBody) ;
                noProcessors.add(noProcessor) ;
                //Debug.println("instanceof is run...."+pBody) ;
            }
            pBody=processor.process(pBody) ;

        }
        pBody=pBody.trim() ;
        
        //ȽвֵıǩҪ
        for(int j=noProcessors.size()-1;j>=0 ;j--){
            noProcessor=(NoWikiTagProcessor)noProcessors.get(j) ;
            pBody=noProcessor.makeUp(pBody) ;

        }
        noProcessors.clear() ;
        
        return pBody;
    }

    public  TagProcessor getProcessor(String pProcessorName){
         return (TagProcessor)processors.get(pProcessorName) ;
    }


    private void loadProcessors(){
        Debug.println("Loading processors....") ;
        
        List nodeList = WebPMConfig.getProperties(processorMap);
        for(int i=0;i< nodeList.size() ;i++){
        	
            Element node = (Element)nodeList.get(i) ;
			String className = node.getText();			
            String tagName=node.getName();
            
            WebPMConfig.logger.info("load "+tagName+" "+className+".....") ;
            try{
                Class c=Class.forName(className) ;
                TagProcessor processor=(TagProcessor)c.newInstance() ;
                processors.put(tagName,processor); //
                processList.add(processor) ; //봦б
                WebPMConfig.logger.info("OK");
//                Debug.println("OK") ;
            }catch(Exception e){
//                Debug.println("FALSE") ;
//                e.printStackTrace();
//                Debug.println(e.toString() ) ;
				WebPMConfig.logger.error(e);
            }
        }
        //Debug.println("Exit")  ;
        WebPMConfig.logger.info("Exit!");
    }

}