/**
 * $RCSfile: WebPMConfig.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 Softme Sutdio. All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.pub ;

import java.io.InputStream;
import java.net.URL;
import java.net.URLDecoder;
import java.util.List;

import org.apache.log4j.Logger;
import org.softme.webpm.utility.XMLPropertyUtility;

/*
 * ϵͳù
 *	<p>XMLԴοJive 2.0еĴ
 * @author BrokenDoor
 * @version 1.2.2
 */

public class WebPMConfig {

	public static Logger logger = Logger.getLogger("WebPM");
	
    static private WebPMConfig configInstance=null;    
	
	private static final String WEBPM_CONFIG_PATH = "conf";
	private static final String WEBPM_CONFIG_FILENAME = "webpm_config.xml";
	//private static final String WEBPM_CONFIG_LOGGER = "webpm.logger.cfg";
	
    public static String SEPARATOR=(System.getProperties()).getProperty("file.separator");
    
    public static String webpmHome=null;

	/**
	 * WebPMԱ
	 */    
    //static private HashMap properties=null;

    /**
     * 汾1.2.2 ʹõXMLԱοJive 2.0Ĳִ
     */
    private static XMLPropertyUtility xmlProperties = null;

	private WebPMConfig() {         
	}
	
	private static void initInstance(){
		configInstance=new WebPMConfig();
				
		Debug.println("Config properties....") ;
		//v1.2.2 removed by brokendooor - 2002/8/11
        //configInstance.loadFilePath() ;
        //configInstance.loadProperties();	
        
        //v1.2.2 ʹjdomXMLԶȡ
        loadXMLProperties();
        
        //WebPM.Home
        //configInstance.setProperty("WebPM.Home", webpmHome);
       	 
        Debug.println("WebPM Config properties Done!") ;
	}
	
    /**
     * added by BrokenDoor - 2002-2-17
     * for reload configInstance
     */
    public static void reload(){
    	configInstance = null;
    	xmlProperties = null;
    	Debug.println("Config released OK!") ;
    	initInstance();
    }

    /**
     * WebPMConfig.class·жWebPM_HOME
     */
    public static String getWebpmHome(){
    	String pmHome = null;
    	
    	if (webpmHome!=null) return webpmHome;

        ClassLoader systemClassLoader =WebPMConfig.class.getClassLoader();
        if (systemClassLoader == null) {
           // antHome = determineAntHome11();
           System.out.println("ClassLoader error") ;
        }
        else {
            pmHome = determineWebPMHome(systemClassLoader);
        }
        if (pmHome == null) {
            System.err.println("Unable to determine WebPM_HOME");
           // System.exit(1);
        }
		webpmHome = pmHome;
        return pmHome;
    }
    
    /**
     * v1.2.2 ȡwebpm_config.xmlе
     */
    private synchronized static void loadXMLProperties() {
        
        if (xmlProperties == null) {
            // If webpmHome is still null, no outside process has set it and
            // we have to attempt to load the value from jive_init.properties,
            // which must be in the classpath.
            if (webpmHome == null) {
                //webpmHome = getWebpmHome();
            }
            
            //Create a manager with the full path to the xml config file.
            /*System.out.println("WebPMConfigFile:" + webpmHome + WEBPM_CONFIG_PATH + SEPARATOR + 
			WEBPM_CONFIG_FILENAME) ;
			
            xmlProperties = new XMLPropertyUtility(webpmHome + WEBPM_CONFIG_PATH + SEPARATOR + 
                    WEBPM_CONFIG_FILENAME);
            */                          
			ClassLoader systemClassLoader =WebPMConfig.class.getClassLoader();
			InputStream file = systemClassLoader.getResourceAsStream(WEBPM_CONFIG_FILENAME);
			xmlProperties = new XMLPropertyUtility(file);        
        }
    }

    /**
     * ȡֵ
     *
     * @param name 
     * @return ֵ
     */
    public static String getProperty(String name) {
        loadXMLProperties();
        return xmlProperties.getProperty(name);
    }

    /**
     * ȡָƵ
     *
     * @param name .
     * @return Ԫб.
     */
    public static List getProperties(String name) {
    	List propList = null;
        loadXMLProperties();
        propList = xmlProperties.getProperties(name); 
        return propList;
    }

	/**
     * ֵԲڣ򴴽
     *
     * @param name 
     * @param value Ҫõֵ
     */
    public static void setProperty(String name, String value) {
        loadXMLProperties();
        xmlProperties.setProperty(name, value);
    }

    /**
     * ɾһԡԲڣ򲻽κδ
     *
     * @param name Ҫɾ
     */
    public static void deleteProperty(String name) {
        loadXMLProperties();
        xmlProperties.deleteProperty(name);
    }
	
	static private String determineWebPMHome(ClassLoader systemClassLoader) {
		
		String className =WebPMConfig.class.getName().replace('.', SEPARATOR.charAt(0)) + ".class";

		System.out.println(className);

		URL classResource = systemClassLoader.getResource(className);
		String fileComponent = classResource.getPath();
		System.out.println("fileComponent:" + fileComponent) ;
		
		//File webPMDir=new File(fileComponent);
		//String dirName=webPMDir.toString();
		String dirName = fileComponent;            
		String webPMHome=URLDecoder.decode( dirName.substring(0,dirName.indexOf("WEB-INF")));
		
		System.out.println("WebPM_HOME:" + webPMHome) ;

/*		String loggerConfigFile = webPMHome + WEBPM_CONFIG_PATH + SEPARATOR + WEBPM_CONFIG_LOGGER;
		System.out.println("loggerConfigFile: " + loggerConfigFile) ;
		PropertyConfigurator.configure(loggerConfigFile);
*/
        return webPMHome;
	}

}