package org.softme.webpm.servlet.file;

import java.io.IOException;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.info.user.User;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

import com.oreilly.servlet.MultipartRequest;


/**
 *  <p>
 *
 *  Title: </p> UploadFile.java<p>
 *
 *  Description: </p> this servlet is for uploading files<p>
 *
 *  Copyright: Copyright (c) 2002</p> <p>
 *
 *  Company: webpm</p>
 *
 *@author     ymruan (ymruan@163.net)
 *@created    2002227
 *@version    1.0
 */

public class UploadFile extends HttpServlet {

	private final int maxFileSize =1024 * 1024 * 10 * 10 ; //10 mb
    /**
     *  Description of the Method
     *
     *@exception  ServletException  Description of the Exception
     */
    public void init() throws ServletException { }


    //Process the HTTP Get request

    /**
     *  Description of the Method
     *
     *@param  request               Description of the Parameter
     *@param  response              Description of the Parameter
     *@exception  ServletException  Description of the Exception
     *@exception  IOException       Description of the Exception
     */
    public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        doPost(request, response);
    }


    //Process the HTTP Post request

    /**
     *  Description of the Method
     *
     *@param  request               Description of the Parameter
     *@param  response              Description of the Parameter
     *@exception  ServletException  Description of the Exception
     *@exception  IOException       Description of the Exception
     */
    public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
    	String gPageRoot = WebPMConfig.getProperty("Site.DefaultRoot");
            
        try {
            HttpSession session = request.getSession();
            String userName     = null    ;
            
            if(session.getAttribute("user")!=null){
              	userName=((User)session.getAttribute("user")).getUserName();
            }
            if(userName!=null){
              	userName=  userName.trim().toLowerCase();
            }
            else{
              	userName = "public";
            }
            String baseDir = "doc/users/";
            if(WebPMConfig.getProperty("UploadFile.BaseDir")!=null ){
              	baseDir = WebPMConfig.getProperty("UploadFile.BaseDir");
            }
            
			ServletContext servletContext = getServletContext();

            String savePath = servletContext.getRealPath(baseDir) + "/" + userName;
			Debug.println("savePath:" + savePath);                        
           /*
            if(WebPMConfig.getProperty("UploadFile.URI")!=null){
              if(WebPMConfig.getProperty("UploadFile.URI").trim().length()!=0){
                maxFileSize = Integer.parseInt(WebPMConfig.getProperty("UploadFile.URI"));
              }
            }
            */
            MultipartRequest uploadRequest = new MultipartRequest(request,savePath,maxFileSize,true);
            response.sendRedirect( gPageRoot + "file/file_upload.jsp");
        } catch (Exception e) {
            e.printStackTrace();
            response.sendRedirect( gPageRoot + "file/file_upload_error.jsp");

        }

    }

    //Clean up resources

    /**
     *  Description of the Method
     */
    public void destroy() {
        System.out.println("Servlet destory.........");
    }
}
