package org.softme.webpm.servlet.project;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.info.project.Project;
import org.softme.webpm.info.project.ProjectFactory;
import org.softme.webpm.info.project.ProjectNotFoundException;
import org.softme.webpm.pub.Debug;
import org.softme.webpm.utility.StringUtility;

public class ProjectControl extends HttpServlet {
	private static final String CONTENT_TYPE = "text/html; charset=GB2312";
	
	/**Initialize global variables*/
	public void init() throws ServletException {

	}

	/**Process the HTTP Get request*/
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType(CONTENT_TYPE);
		
		PrintWriter out = response.getWriter();
	    HttpSession session=request.getSession() ;
	    String pid = null;
	    String memberName = null;
		String url = "";
		String errors ="";
		String sAction = request.getParameter("action");
		
		ProjectFactory pf = ProjectFactory.getInstance();
		Project prj = null;
		
		if (sAction==null){
			try {									
				prj = this.parseRegister(request,response);
					
				if (prj==null) 
				{
					url = "/webpm/project/prj_register_error.jsp";
				} else {											
					if (prj.getProjectID() > 0 ) {					
						url = "/webpm/project/prj_register_success.jsp?action=modify";
					} else {					
						url = "/webpm/project/prj_register_success.jsp";					
					}								
					prj.save();
				};				
			}
			catch(Exception e) {
			  	e.printStackTrace();
			  	url = "/webpm/project/prj_register_error.jsp";
			}
				
		}else if (sAction.equalsIgnoreCase("addmember")){
			try{
				memberName = StringUtility.encodeRequest2Memory(request.getParameter("membername"));
				pid = request.getParameter("pid");
				prj = pf.getProject(Integer.parseInt(pid));
				prj.addMember(memberName);
				
				url = "/webpm/project/prj_member_success.jsp";
				
			}catch(Exception e){
				e.printStackTrace();
				errors = "ĿԱʧܣ";
				session.setAttribute("errors", errors);
				url = "/webpm/project/prj_member_error.jsp";
			}
			
		}else if (sAction.equalsIgnoreCase("removemember")){
			errors = "ɾĿԱʧܣ<br>";
			try{
				memberName = StringUtility.encodeRequest2Memory(request.getParameter("membername"));
				pid = request.getParameter("pid");
				prj = pf.getProject(Integer.parseInt(pid));
				prj.removeMember(memberName);				
				url = "/webpm/project/prj_member_success.jsp?action=modify";
			}catch(Exception e){
				e.printStackTrace();				
				errors += e.toString();
				session.setAttribute("errors", errors);
				url = "/webpm/project/prj_member_error.jsp";
			}
					
		} else {
			url = "/webpm/"	;
		}	
		
		response.sendRedirect(url) ;		
	}
	
	// ĿעϢȷԷ
	private Project parseRegister(HttpServletRequest req, HttpServletResponse res) {

		HttpSession session=req.getSession() ;
		
		// Ŀ		
		Project prj = null;
		
		// Ϣ
		String errors = "";				
		String sPrjName = "";
		String sPrjKeywords = "";
		String sPrjDesc = "";
		String sPrjFlag = "";
		
		String pid = req.getParameter("pid");
		
		ProjectFactory pf = ProjectFactory.getInstance();
		
		Debug.println("ProjectID=" + pid);
		
		int id = Integer.parseInt(pid);
		if (id > 0){
			try{
				prj = pf.getProject(id);
				sPrjName = prj.getProjectName();
			}
			catch(ProjectNotFoundException e)	{
				e.printStackTrace();
				return null;
			}		
		} else {			
			// עĿ
			// Ŀж
			sPrjName = req.getParameter("prjname");		
		
			if (sPrjName==null||sPrjName.length()<=0) {
				errors += "ĿΪ;<br>" ;			
			}else {
				try{
					sPrjName = StringUtility.encodeRequest2Memory(sPrjName);
					prj = pf.getProject(sPrjName);
					errors += "Ŀ" + sPrjName + "Ѿڣ;<br>";				
				} catch (ProjectNotFoundException e){
					
				};
			};
			prj = pf.createProject();
		};
	
		// ؼֿж
		sPrjKeywords = req.getParameter("prjkeywords");
		if (sPrjKeywords==null||sPrjKeywords.length()<=0) {
			errors += "Ŀؼûд;<br>";			
		};

		// 
		if (errors.length() > 0) {
		    session.setAttribute("registerErrors", errors);
			return null;
		} 
		
		prj.setProjectName(sPrjName);
		prj.setKeywords(StringUtility.encodeRequest2Memory(sPrjKeywords));
		prj.setDescription(StringUtility.encodeRequest2Memory(req.getParameter("prjdesc")));
		prj.setAuthor(StringUtility.encodeRequest2Memory(req.getParameter("prjauthor")));
		return prj;
		
	}   //  praseRegister()'s end

	/**Clean up resources*/
	public void destroy() {

	}
}