package org.softme.webpm.servlet.user;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserFactory;
import org.softme.webpm.info.user.UserNotFoundException;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.CookieUtility;
import org.softme.webpm.utility.StringUtility;

public class UserLogin extends HttpServlet {
	private static final String CONTENT_TYPE = "text/html; charset=GB2312";
	/**Initialize global variables*/
	public void init() throws ServletException {

	}

	/**Process the HTTP Get request*/
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType(CONTENT_TYPE);
		
		PrintWriter out = response.getWriter();
	    HttpSession session=request.getSession() ;
	    
	    String urlRoot= WebPMConfig.getProperty("Site.DefaultRoot");	  
		String url = "";
		
		try {
			String sAction = request.getParameter("action");
			if (sAction==null||sAction.length() <= 0) {
				sAction = "login";				
			}
			
			if (sAction.equalsIgnoreCase("logout"))
			{
				// ɾûcookie
				CookieUtility.deleteCookie(response, "user");				
				session.setAttribute("user", null);
				url = urlRoot;
			}else{
				String sUsername = StringUtility.encodeRequest2Memory(request.getParameter("username"));
				String sPassword = StringUtility.encodeRequest2Memory(request.getParameter("password"));
				UserFactory um = UserFactory.getInstance();
				try {
					User user = um.getUser(sUsername);
				
					if (user!=null) 
					{
						if (user.getPassword()!=null && user.getPassword().equals(sPassword) == false)
						{ 
							url = urlRoot +"user/user_login_error.jsp";
						} else {
							// ޸ģʹcookieû
							CookieUtility.setCookie(response,"user",Integer.toString(user.getUserID()));
							session.setAttribute("user", user);
							url = urlRoot;
						};						
					} else {					
						url = urlRoot + "user/user_login_error.jsp";
					};				
				} catch (UserNotFoundException e) {
					url = urlRoot + "user/user_login_error.jsp";
				};
				
				// ʼ¼
				session.setAttribute("visitlist", null);
			};						
		}
		catch(Exception e) {
		  	e.printStackTrace();
		}
		
		response.sendRedirect(url) ;
	}
	
	/**Clean up resources*/
	public void destroy() {

	}
}