package org.softme.webpm.servlet.user;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserFactory;
import org.softme.webpm.info.user.UserHasAlreadyExistsException;
import org.softme.webpm.info.user.UserNotFoundException;
import org.softme.webpm.pub.WebPMConfig;
import org.softme.webpm.utility.CookieUtility;
import org.softme.webpm.utility.StringUtility;

public class UserRegister extends HttpServlet {
	private static final String CONTENT_TYPE = "text/html; charset=GB2312";
        private UserFactory um=UserFactory.getInstance() ;

	/**Initialize global variables*/
	public void init() throws ServletException {

	}

	/**Process the HTTP Get request*/
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType(CONTENT_TYPE);

		PrintWriter out = response.getWriter();
	    HttpSession session=request.getSession() ;
	    
	    String urlRoot= WebPMConfig.getProperty("Site.DefaultRoot");	  		
		String url = "";
		try {
			String sAction = request.getParameter("action");
			//Debug.println(sAction);

			User user = this.parseRegister(request,response);

			if (user==null)
			{
				url = urlRoot + "user/user_register_error.jsp";
			} else {
				if (sAction !=null && sAction.equalsIgnoreCase("modify")) {
					user.save();

					url = urlRoot + "user/user_register_success.jsp?action=modify";
				} else {
                    try{
				        um.registerUser(user) ;

	                  //  System.out.print(user.getUsername() ) ;
	                    session.setAttribute("visitlist", null);
	                    url = urlRoot + "user/user_register_success.jsp";
	                    session.setAttribute("user", user);
	                    // ޸ģʹcookieû
	                    CookieUtility.setCookie(response, "user", Integer.toString(user.getUserID()));

                    }catch(UserHasAlreadyExistsException e){
                        url = urlRoot + "user/user_register_error.jsp";
                        String errors="û:"+user.getUserName()+"Ѿ";
                        session.setAttribute("registerErrors", errors);
                    }

				}
			};
		}
		catch(Exception e) {
		  	e.printStackTrace();
		  	url = urlRoot + "user/user_register_error.jsp";
		}
                //System.out.print(url) ;
		response.sendRedirect(url) ;
	}

	// ûעϢȷԷ
	private User parseRegister(HttpServletRequest req, HttpServletResponse res) {

		HttpSession session=req.getSession() ;

		// û
		User user = null;

		// Ϣ
		String errors = "";
		String sUsername = "";

		String action = req.getParameter("action");

		UserFactory um = UserFactory.getInstance();

		if (action!=null&&action.equalsIgnoreCase("modify"))
		{			
			String sUserID = CookieUtility.getCookie(req.getCookies(), "user");
			try{
				user = um.getUser(Integer.parseInt(sUserID));
				sUsername = user.getUserName();
			}
			catch(UserNotFoundException e)
			{
				e.printStackTrace();
				return null;
			}

		} else {

			user = um.createUser();

			// ûж
			sUsername = req.getParameter("username");

			if (sUsername==null||sUsername.length()<=0) {
				errors += "ûΪ;<br>" ;
			}
		};

		// ж
		if (req.getParameter("password1").length()<0) {
			errors += "벻Ϊ;<br>";
		} else if (req.getParameter("password2").length()<0) {
			// ȷϿж
			errors += "ȷϲΪ<br>";
		} else if (!(req.getParameter("password2").equals(req.getParameter("password1")))) {
			// ȷһж
			errors += "ȷϲһ<br>";
		};

		// E-mail ж
		if (req.getParameter("email").length()<0) {
			errors += "E-mailûд;<br>";
		};

		// E-mai Ϸж
		boolean bFind = false;
		String strEmail = req.getParameter("email");
		for (int j=0; j < strEmail.length(); j++) {
			String cha = String.valueOf(strEmail.charAt(j));
			if (cha.equals("@")) {
				bFind = true;
				break;
			};
		};
		if (bFind==false){
			errors += "E-mail Ϸ;<br>";
		};

		// ȡʾж
		if (req.getParameter("question").length()<0) {
			errors += "ȡʾûд;<br>";
		};

		// ȡ𰸿ж
		if (req.getParameter("answer").length()<0) {
			errors += "ȡûд;<br>";
		};

		// 
		if (errors.length() > 0) {
		    session.setAttribute("registerErrors", errors);
			return null;
		} else {

			//  user  phone ֵ
			if (req.getParameter("phone").length()<0) {
				user.setPhone("");
			}
			else {
				user.setPhone(StringUtility.encodeRequest2Memory(req.getParameter("phone")));
			};

			////  user  address ֵ
			if (req.getParameter("address").length()<0) {
				user.setAddress("");
			}
			else {
				user.setAddress(StringUtility.encodeRequest2Memory(req.getParameter("address")));
			};

			////  user  memo ֵ
			if (req.getParameter("memo").length()<0) {
				user.setMemo("");
			}
			else {
				user.setMemo(StringUtility.encodeRequest2Memory(req.getParameter("memo")));
			};

			////  user  username ֵ
			user.setUserName(StringUtility.encodeRequest2Memory(sUsername));

			////  user  password ֵ
			user.setPassword(StringUtility.encodeRequest2Memory(req.getParameter("password1")));

			////  user  question ֵ
			user.setQuestion(StringUtility.encodeRequest2Memory(req.getParameter("question")));

			////  user  answer ֵ
			user.setAnswer(StringUtility.encodeRequest2Memory(req.getParameter("answer")));

			////  user  E-mail ֵ
			user.setEmail(StringUtility.encodeRequest2Memory(req.getParameter("email")));

			////  user  sex ֵ
			user.setSex(req.getParameter("sex"));

			////  user  birthday ֵ
			user.setBirthday(req.getParameter("year")+"-"+req.getParameter("month")+"-"+req.getParameter("date"));

			return user;
		}
	}   //  praseRegister()'s end

	/**Clean up resources*/
	public void destroy() {

	}
}