package org.softme.webpm.utility ;  
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;

/**
 * Title:        CookieUtility
 * Description:
 * Copyright:    Copyleft (l) 2002
 * Company:      Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */
public class CookieUtility {
	public static final int SECONDS_PER_YEAR = 60*60*24*365;

	
	private CookieUtility() {
	}

	public static void setCookie(HttpServletResponse response, String pName, String pValue) {
		Cookie mycookie = new Cookie(pName, StringUtility.encodeMemory2URL(pValue));
		mycookie.setPath("/");
		mycookie.setMaxAge(SECONDS_PER_YEAR);
		response.addCookie(mycookie);
		return;
	}

	public static void deleteCookie(HttpServletResponse response, String pName) {
		Cookie mycookie = new Cookie(pName,null);
		mycookie.setMaxAge(0);
		mycookie.setPath("/");
		response.addCookie(mycookie);
		return;
	}

	public static String getCookie(Cookie[] infos, String pName){		
		Cookie info = null;		
		// Get all the cookies that came with the request
		for(int i = 0; i < infos.length; i++) {
			info = infos[i];
			if (info.getName().equals(pName)) {
				return info.getValue();					
			}
		}

		return null;

	}
}
