/**
 * $RCSfile: StringUtility.java,v $
 * $Revision: 1.2 $
 * $Date: 2004/01/15 14:11:24 $
 *
 * Copyright (C) 2001-2002 softme.org (Softme Studio). All rights reserved.
 * ===================================================================
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL COOLSERVLETS INC. OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 */

package org.softme.webpm.utility ;

import org.softme.webpm.pub.Debug;
import org.softme.webpm.pub.WebPMConfig;

/**
 * ַ봦
 * @author , BrokenDoor
 * @version 1.0
 */

public class StringUtility {

	private StringUtility() {
	}
	
	public static String encodeDB2Memory(String pString){
		return encode(pString,
			WebPMConfig.getProperty("Encoder.DB2Memory.GetBytes"),
			WebPMConfig.getProperty("Encoder.DB2Memory.Code"));
	
	}  
	public static String encodeMemory2DB(String pString){
		return encode(pString,
			WebPMConfig.getProperty("Encoder.Memory2DB.GetBytes"),
			WebPMConfig.getProperty("Encoder.Memory2DB.Code"));
	}
	
	public static String encodeRequest2Memory(String pString){
		return encode(pString,
			WebPMConfig.getProperty("Encoder.Request2Memory.GetBytes"),
			WebPMConfig.getProperty("Encoder.Request2Memory.Code"));
	
	}  
	public static String encodeMemory2Response(String pString){
		return encode(pString,
			WebPMConfig.getProperty("Encoder.Memory2Response.GetBytes"),
			WebPMConfig.getProperty("Encoder.Memory2Response.Code"));
	}
	
	public static String encodeMemory2URL(String pString){
		return encode(pString,
			WebPMConfig.getProperty("Encoder.Memory2URL.GetBytes"),
			WebPMConfig.getProperty("Encoder.Memory2URL.Code"));
	}
	public static String encodeURL2Memory(String pString){
	
		return encode(pString,
			WebPMConfig.getProperty("Encoder.URL2Memory.GetBytes"),
			WebPMConfig.getProperty("Encoder.URL2Memory.Code"));
	
	}
	
	public static String URLEncode(String pString){
		return java.net.URLEncoder.encode(pString);
	}
	
	private static String encode(String pString ,String pGetBytesCode,String pCode){
		String encodedString = pString;
		if(pString==null||pString.equals("")){
			return encodedString;
		}
	
		if(pCode.equalsIgnoreCase("")||pGetBytesCode.equalsIgnoreCase(""))  {
			return encodedString;
		}
	
		try{
			encodedString=new String(pString.getBytes(pGetBytesCode),pCode);
		}catch(Exception e){
			e.printStackTrace() ;
			Debug.println(e.toString() );
		}
	
		return encodedString;
	}
	
	public static boolean isNumeric(String number)
	{
		try
		{
   			Integer.parseInt(number);
   			return true;
		}
		catch(NumberFormatException sqo)
		{
   			return false;
		}
	}
}
