package org.softme.webpm.test;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.apache.log4j.Logger;

/**
 * Title:        Project Test
 * Description:
 * Copyright:    Copyleft (l) 2002
 * Company:      Softme Studio
 * @author BrokenDoor
 * @version 1.0
 */

public class WebPMTest extends TestCase{
	
	static Logger logger = Logger.getLogger(WebPMTest.class.getName());
	public WebPMTest(String name) {
		super(name);
	}

	public static Test suite(){
		
		TestSuite suite = new TestSuite();
		suite.addTestSuite(WebPMTest.class);

		// test.pub
		suite.addTestSuite(org.softme.webpm.test.pub.WebPMConfigTest.class);
		suite.addTestSuite(org.softme.webpm.test.pub.ConnectionManagerTest.class);
		suite.addTestSuite(org.softme.webpm.test.pub.DBConnectionTest.class);
		suite.addTestSuite(org.softme.webpm.test.pub.LanguageTest.class);

		// test.utility
		suite.addTestSuite(org.softme.webpm.test.utility.DateTimeUtilityTest.class);

		// test.jwiki. ȲFactoryٲArticle
		//suite.addTestSuite(org.softme.webpm.jwiki.ArticleFactoryImpTest.class);

		//suite.addTestSuite(org.softme.webpm.jwiki.ArticleTest.class);

		suite.addTestSuite(org.softme.webpm.test.jwiki.TagProcessorFactoryTest.class);

		// test.info.user
		suite.addTestSuite(org.softme.webpm.test.info.user.UserFactoryTest.class);

		// test.info.project
		suite.addTestSuite(org.softme.webpm.test.info.project.ProjectTest.class);
		
		return suite;
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite());
	}

	public void testWebPM(){
		int pid = Integer.parseInt("-1");
		
		//Debug.println(Integer.toString(pid));
		// replaced by log4j
		logger.debug("First log by log4j: " + Integer.toString(pid));
		//fail("This is a error! - BrokenDoor");
		return;
	}
}