package org.softme.webpm.test.info.user;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.softme.webpm.info.user.User;
import org.softme.webpm.info.user.UserFactory;
import org.softme.webpm.info.user.UserHasAlreadyExistsException;
import org.softme.webpm.info.user.UserImp;
import org.softme.webpm.info.user.UserNotFoundException;


/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class UserFactoryTest extends TestCase{
  private UserFactory um = UserFactory.getInstance();
  private String userName="tester";
  private String userPass="testpass";
  public UserFactoryTest(String name) {
    super(name);
  }

  public static Test suite(){
        return new TestSuite(UserFactoryTest.class);
  }

  public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
  }
  public void testCreateUser(){
      try{
          User newU= new UserImp();
          newU.setUserName(userName) ;
          newU.setPassword(userPass) ;
          um.registerUser(newU);
          assertEquals(newU.getUserName(),userName);
          assertEquals(newU.getPassword(),userPass);
      } catch(UserHasAlreadyExistsException e) {

      }
  }
  public void testGetUser(){
      try{
          User existingUser = um.getUser(userName);
          assertEquals(existingUser.getUserName(),userName);
          assertEquals(existingUser.getPassword(),userPass);
      } catch(UserNotFoundException e) {
          fail(e.getMessage()); //ڣʧ
      }
  }

}