package org.softme.webpm.test.jwiki;
import java.util.Iterator;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.softme.webpm.jwiki.article.Article;
import org.softme.webpm.jwiki.article.ArticleFactory;
import org.softme.webpm.jwiki.exception.ArticleAlreadyExistsException;
import org.softme.webpm.jwiki.exception.ArticleNotFoundException;
import org.softme.webpm.jwiki.query.Query;
/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleFactoryImpTest extends TestCase{
	private  ArticleFactory arFactory=ArticleFactory.getInstance();

	private String gTopic="test",gBody="testbody",gAuthor="tester";

	private int mBackupTopicID=1;  //ѾڵһID

	public ArticleFactoryImpTest(String name) {
		super(name);
	}

	public static Test suite(){
		return new TestSuite(ArticleFactoryImpTest.class);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite()) ;
	}
        //ʱȴ
	public void testCreate(){
		try{
			Article newArticle=arFactory.createArticle(gTopic,gBody,gAuthor);
			assertEquals(newArticle.getTopic(),gTopic);
			assertEquals(newArticle.getBody(),gBody);
			assertEquals(newArticle.getAuthor(),gAuthor);
			assertEquals(newArticle.getMender(),gAuthor);//ʱĬ޸Ϊ
		}catch(ArticleAlreadyExistsException e){
			//ڣͨ
		}
	}

	public void testGetArticle(){
		try{
			Article existingAr=arFactory.getArticle(gTopic);
			assertEquals(existingAr.getTopic(),gTopic);
			assertEquals(existingAr.getBody(),gBody);
			assertEquals(existingAr.getAuthor(),gAuthor);
		}catch(ArticleNotFoundException e){
			fail(e.getMessage());
		}
	}

	public void testRecentChanges(){
		Iterator articleIterator=arFactory.getRecentChanges();
		Article recentAr=null;

		while(articleIterator.hasNext()){
			recentAr=(Article)articleIterator.next() ;
			assertTrue(recentAr.getTopic()!=null);
			assertTrue(recentAr.getBody()!=null);
		}
	}

	public void testRevert(){
		try{
			Article backupAr=arFactory.revert(mBackupTopicID) ;
			Article existingAr=arFactory.getArticle(backupAr.getTopic());

			assertEquals(backupAr.getTopic(),existingAr.getTopic());
			assertEquals(backupAr.getBody(),existingAr.getBody());
			assertEquals(backupAr.getAuthor(),existingAr.getAuthor());
			assertEquals(backupAr.getMender(),existingAr.getMender());

		}catch(Exception e){
			e.printStackTrace() ;
			fail(e.getMessage());
		}
	}

	public void testQuery(){
		boolean isSuccess=false;
		Query query=arFactory.createQuery(gTopic);
		Iterator topicResult=query.searchTopic();
		Iterator bodyResult=query.searchBody();
		Article queryAr=null;

		while(topicResult.hasNext()){
			queryAr=(Article)topicResult.next() ;
			if(queryAr.getTopic().equals(gTopic)){
				isSuccess=true;
			}
		}
		assertTrue(isSuccess);
		isSuccess=false;
		while(bodyResult.hasNext()){
			queryAr=(Article)bodyResult.next() ;
			if(queryAr.getTopic().equals(gTopic)){
				isSuccess=true;
			}
		}
		assertTrue(isSuccess);
	}


}