package org.softme.webpm.test.jwiki;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.softme.webpm.jwiki.article.ArticleTemplate;
import org.softme.webpm.jwiki.article.ArticleTemplateFactory;
import org.softme.webpm.jwiki.exception.ArticleTemplateAlreadyExistsException;
import org.softme.webpm.jwiki.exception.ArticleTemplateNotFoundException;
/**
  * <p>  wiki ģĹ
  * Copyleft (l) 2001-2002 Softme Studio
  * @author BrokenDoor
  * @version 1.0
  */
 
public class ArticleTemplateFactoryTest extends TestCase{
	private  ArticleTemplateFactory atf = ArticleTemplateFactory.getInstance();

	private String gTopic="{project.name}.test",gBody="{project.info}", gAuthor="tester";

	private int mBackupTopicID=1;  //ѾڵһID

	public ArticleTemplateFactoryTest(String name) {
		super(name);
	}

	public static Test suite(){
		return new TestSuite(ArticleTemplateFactoryTest.class);
	}

	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite()) ;
	}
 
	//ʱȴ
	public void testCreate(){
		try{
			ArticleTemplate newArticleTemplate = atf.createArticleTemplate(gTopic,gBody,gAuthor);
			assertEquals(newArticleTemplate.getTopic(),gTopic);
			assertEquals(newArticleTemplate.getBody(),gBody);
			assertEquals(newArticleTemplate.getAuthor(),gAuthor);
			assertEquals(newArticleTemplate.getMender(),gAuthor);//ʱĬ޸Ϊ
		}catch(ArticleTemplateAlreadyExistsException e){
			//ڣͨ
		}
	}

	public void testGetArticleTemplate(){
		try{
			ArticleTemplate existingAt = atf.getArticleTemplate(gTopic);
			assertEquals(existingAt.getTopic(),gTopic);
			assertEquals(existingAt.getBody(),gBody);
			assertEquals(existingAt.getAuthor(),gAuthor);
		}catch(ArticleTemplateNotFoundException e){
			fail(e.getMessage());
		}
	}

}