package org.softme.webpm.test.jwiki;

import junit.framework.TestCase;
import junit.framework.TestSuite;

import org.softme.webpm.jwiki.article.Article;
import org.softme.webpm.jwiki.article.ArticleFactory;
import org.softme.webpm.jwiki.exception.ArticleNotFoundException;

/**
 * Title:        WebPM
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      WebPM
 * @author 
 * @version 1.0
 */

public class ArticleTest extends TestCase{
	private String mTopic = "test";
	private String mNewBody="testbody";
	private	String mMender="tester";
			
  	private  ArticleFactory arFactory=ArticleFactory.getInstance() ;
	public ArticleTest(String name) {
		super(name);
	}
	
	public static void main(String[] args) {
		junit.textui.TestRunner.run(ArticleTest.class) ;
	}
	
	public static TestSuite suite(){
		return new TestSuite(ArticleTest.class);
	}
	
	public void testModify(){
		try{
			Article existingAr=arFactory.getArticle(mTopic);
			existingAr.setBody(mNewBody);
			existingAr.setMender(mMender);
			existingAr.modifyBody();
			existingAr=arFactory.getArticle(mTopic);
			assertEquals(existingAr.getTopic(),mTopic);
			assertEquals(existingAr.getBody(),mNewBody);
			assertEquals(existingAr.getMender(),mMender);
		}catch(Exception e){
			System.out.print(e.toString() ) ;
			fail();
		}
	}

	public void testLock(){
		try{
			Article existingAr=arFactory.getArticle(mTopic);
			existingAr.changeFlag(Article.LOCK);
			existingAr=arFactory.getArticle(mTopic);
			assertEquals(existingAr.getFlag(),Article.LOCK);
		}catch(ArticleNotFoundException e){
			fail(e.getMessage());
		}
	
	}
	
	public void testUnLock(){
		try{
			Article existingAr=arFactory.getArticle(mTopic);
			existingAr.changeFlag(Article.UNLOCK ) ;
			existingAr=arFactory.getArticle(mTopic);
			assertEquals(existingAr.getFlag() ,Article.UNLOCK);
		}catch(Exception e){
			fail(e.getMessage());
		}	
	}
}